# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`icingaweb2`](#icingaweb2): Installs and configures Icinga Web 2.
* [`icingaweb2::globals`](#icingaweb2--globals): This class loads the default parameters by doing a hiera lookup.
* [`icingaweb2::module::audit`](#icingaweb2--module--audit): Installs and enables the audit  module.
* [`icingaweb2::module::businessprocess`](#icingaweb2--module--businessprocess): Installs and enables the businessprocess module.
* [`icingaweb2::module::cube`](#icingaweb2--module--cube): Installs and enables the cube module.
* [`icingaweb2::module::director`](#icingaweb2--module--director): Install and configure the director module.
* [`icingaweb2::module::doc`](#icingaweb2--module--doc): The doc module provides an interface to the Icinga 2 and Icinga Web 2 documentation.
* [`icingaweb2::module::elasticsearch`](#icingaweb2--module--elasticsearch): The Elasticsearch module displays events from data stored in Elasticsearch.
* [`icingaweb2::module::fileshipper`](#icingaweb2--module--fileshipper): The fileshipper module extends the Director. It offers import sources to deal with CSV, JSON, YAML and XML files.
* [`icingaweb2::module::generictts`](#icingaweb2--module--generictts): Installs and enables the generictts module.
* [`icingaweb2::module::graphite`](#icingaweb2--module--graphite): The Graphite module draws graphs out of time series data stored in Graphite.
* [`icingaweb2::module::icingadb`](#icingaweb2--module--icingadb): Manages the icingadb module. This module is still optional at the moment.
* [`icingaweb2::module::idoreports`](#icingaweb2--module--idoreports): Installs, configures and enables the idoreports module. The module is deprecated.
* [`icingaweb2::module::monitoring`](#icingaweb2--module--monitoring): Manages the monitoring module. This module is deprecated.
* [`icingaweb2::module::pdfexport`](#icingaweb2--module--pdfexport): Installs, configures and enables the pdfexport module.
* [`icingaweb2::module::puppetdb`](#icingaweb2--module--puppetdb): Installs and configures the puppetdb module.
* [`icingaweb2::module::reporting`](#icingaweb2--module--reporting): Installs the reporting module
* [`icingaweb2::module::translation`](#icingaweb2--module--translation): Installs and configures the translation module.
* [`icingaweb2::module::vspheredb`](#icingaweb2--module--vspheredb): Installs the vsphereDB plugin
* [`icingaweb2::module::x509`](#icingaweb2--module--x509): Installs the x509 module

#### Private Classes

* `icingaweb2::config`: Configures Icinga Web 2.
* `icingaweb2::install`: Installs Icinga Web 2 and extra packages.
* `icingaweb2::module::director::config`: Configure the director module.
* `icingaweb2::module::director::install`: Install the director module.
* `icingaweb2::module::director::kickstart`: Import or update the database schema. Also start the initial kickstart run if required.
* `icingaweb2::module::director::service`: Manage the director service.
* `icingaweb2::module::icingadb::config`: Configure the icingadb module.
* `icingaweb2::module::icingadb::install`: Install the icingadb module.
* `icingaweb2::module::monitoring::config`: Configure the monitoring module.
* `icingaweb2::module::monitoring::install`: Installs the monitoring module.
* `icingaweb2::module::reporting::config`: Configure the reporting module.
* `icingaweb2::module::reporting::install`: Install the reporting module.
* `icingaweb2::module::reporting::service`: Manage the reporting service.
* `icingaweb2::module::vspheredb::config`: Configure the VSphereDB module
* `icingaweb2::module::vspheredb::install`: Install the VSphereDB module
* `icingaweb2::module::vspheredb::service`: Manage the vspheredb service.
* `icingaweb2::module::x509::config`: Configure the x509 module
* `icingaweb2::module::x509::install`: Install the x509 module
* `icingaweb2::module::x509::service`: Manage the x509 job scheduler.

### Defined types

#### Public Defined types

* [`icingaweb2::config::authmethod`](#icingaweb2--config--authmethod): Manage Icinga Web 2 authentication methods. Auth methods may be chained by setting proper ordering.
* [`icingaweb2::config::dashboard`](#icingaweb2--config--dashboard): Manage a dashboard.
* [`icingaweb2::config::dashlet`](#icingaweb2--config--dashlet): Manage a dashlet.
* [`icingaweb2::config::groupbackend`](#icingaweb2--config--groupbackend): Groups of users can be stored either in a database, LDAP or ActiveDirectory. This defined type configures backends
that store groups.
* [`icingaweb2::config::navigation`](#icingaweb2--config--navigation): Navigate defines a menu entry, host- or service action.
* [`icingaweb2::config::role`](#icingaweb2--config--role): Roles define a set of permissions that may be applied to users or groups.
* [`icingaweb2::inisection`](#icingaweb2--inisection): Manage settings in INI configuration files.
* [`icingaweb2::module`](#icingaweb2--module): Download, enable and configure Icinga Web 2 modules.
* [`icingaweb2::resource::database`](#icingaweb2--resource--database): Create and remove Icinga Web 2 database resources.
* [`icingaweb2::resource::ldap`](#icingaweb2--resource--ldap): Create and remove Icinga Web 2 resources. Resources may be referenced in other configuration sections.

#### Private Defined types

* `icingaweb2::module::elasticsearch::eventtype`: Manages an Elasticsearch event types
* `icingaweb2::module::elasticsearch::instance`: Manages an Elasticsearch instance
* `icingaweb2::module::fileshipper::basedir`: Manages base directories for the fileshipper module.
* `icingaweb2::module::fileshipper::directory`: Manages directories with plain Icinga 2 configuration files.
* `icingaweb2::module::generictts::ticketsystem`: Manages ticketsystem configuration for the generictts module.
* `icingaweb2::module::icingadb::commandtransport`: Manages commandtransport configuration for the icingadb module.
* `icingaweb2::module::monitoring::commandtransport`: Manages commandtransport configuration for the monitoring module.
* `icingaweb2::module::puppetdb::certificate`: Installs a certificate for the Icinga Web 2 puppetdb module.

### Functions

* [`icingaweb2::pick`](#icingaweb2--pick): This function returns first parameter if set.

### Data types

* [`Icingaweb2::AdminRole`](#Icingaweb2--AdminRole): A strict type for the default admin role
* [`Icingaweb2::ImportSchema`](#Icingaweb2--ImportSchema): A type for setting import database schemata

## Classes

### <a name="icingaweb2"></a>`icingaweb2`

`oracle`, `mssql`, `ibm`, `oci`, `sqlite` goes to `icingaweb2::resource::database`.

#### Examples

##### Use MySQL as backend for user authentication:

```puppet
include ::mysql::server

mysql::db { 'icingaweb2':
  user     => 'icingaweb2',
  password => Sensitive('supersecret'),
  host     => 'localhost',
  grant    => [ 'ALL' ],
}

class { 'icingaweb2':
  manage_repos  => true,
  import_schema => true,
  db_type       => 'mysql',
  db_host       => 'localhost',
  db_port       => 3306,
  db_username   => 'icingaweb2',
  db_password   => Sensitive('supersecret'),
  require       => Mysql::Db['icingaweb2'],
}
```

##### Use PostgreSQL as backend for user authentication:

```puppet
include ::postgresql::server

postgresql::server::db { 'icingaweb2':
  user     => 'icingaweb2',
  password => postgresql_password('icingaweb2', Sensitive('icingaweb2')),
}

class { 'icingaweb2':
  manage_repos  => true,
  import_schema => true,
  db_type       => 'pgsql',
  db_host       => 'localhost',
  db_port       => 5432,
  db_username   => 'icingaweb2',
  db_password   => 'icingaweb2',
  require       => Postgresql::Server::Db['icingaweb2'],
}
```

##### Icinga Web 2 with an additional resource of type `ldap`, e.g. for authentication:

```puppet
class { 'icingaweb2':
  resources       => {
    'my-ldap' => {
      type    => 'ldap',
      host    => 'localhost',
      port    => 389,
      root_dn => 'ou=users,dc=icinga,dc=com',
      bind_dn => 'cn=icingaweb2,ou=users,dc=icinga,dc=com',
      bind_pw => Sensitive('supersecret'),
    }
  },
  user_backends   => {
    'ldap-auth' => {
      backend                  => 'ldap',
      resource                 => 'my-ldap',
      ldap_user_class          => 'user',
      ldap_filter              => '(memberof:1.2.840.113556.1.4.1941:=CN=monitoring,OU=groups,DC=icinga,DC=com)',
      ldap_user_name_attribute => 'userPrincipalName',
      order                    => '05',
    },
  },
  group_backends => {
    'ldap-auth' => {
      backend                     => 'ldap',
      resource                    => 'my-ldap',
      ldap_group_class            => 'group',
      ldap_group_name_attribute   => 'cn',
      ldap_group_member_attribute => 'member',
      ldap_base_dn                => 'ou=groups,dc=icinga,dc=com',
      domain                      => 'icinga.com',
      order                       => '05',
    },
  },
}
```

#### Parameters

The following parameters are available in the `icingaweb2` class:

* [`logging`](#-icingaweb2--logging)
* [`logging_file`](#-icingaweb2--logging_file)
* [`logging_level`](#-icingaweb2--logging_level)
* [`logging_facility`](#-icingaweb2--logging_facility)
* [`logging_application`](#-icingaweb2--logging_application)
* [`show_stacktraces`](#-icingaweb2--show_stacktraces)
* [`module_path`](#-icingaweb2--module_path)
* [`theme`](#-icingaweb2--theme)
* [`theme_disabled`](#-icingaweb2--theme_disabled)
* [`manage_repos`](#-icingaweb2--manage_repos)
* [`manage_package`](#-icingaweb2--manage_package)
* [`extra_packages`](#-icingaweb2--extra_packages)
* [`import_schema`](#-icingaweb2--import_schema)
* [`db_type`](#-icingaweb2--db_type)
* [`db_resource_name`](#-icingaweb2--db_resource_name)
* [`db_host`](#-icingaweb2--db_host)
* [`db_port`](#-icingaweb2--db_port)
* [`db_name`](#-icingaweb2--db_name)
* [`db_username`](#-icingaweb2--db_username)
* [`db_password`](#-icingaweb2--db_password)
* [`use_tls`](#-icingaweb2--use_tls)
* [`tls_key_file`](#-icingaweb2--tls_key_file)
* [`tls_cert_file`](#-icingaweb2--tls_cert_file)
* [`tls_cacert_file`](#-icingaweb2--tls_cacert_file)
* [`tls_key`](#-icingaweb2--tls_key)
* [`tls_cert`](#-icingaweb2--tls_cert)
* [`tls_cacert`](#-icingaweb2--tls_cacert)
* [`tls_capath`](#-icingaweb2--tls_capath)
* [`tls_noverify`](#-icingaweb2--tls_noverify)
* [`tls_cipher`](#-icingaweb2--tls_cipher)
* [`conf_user`](#-icingaweb2--conf_user)
* [`conf_group`](#-icingaweb2--conf_group)
* [`default_domain`](#-icingaweb2--default_domain)
* [`cookie_path`](#-icingaweb2--cookie_path)
* [`admin_role`](#-icingaweb2--admin_role)
* [`default_admin_username`](#-icingaweb2--default_admin_username)
* [`default_admin_password`](#-icingaweb2--default_admin_password)
* [`resources`](#-icingaweb2--resources)
* [`default_auth_backend`](#-icingaweb2--default_auth_backend)
* [`user_backends`](#-icingaweb2--user_backends)
* [`group_backends`](#-icingaweb2--group_backends)

##### <a name="-icingaweb2--logging"></a>`logging`

Data type: `Enum['file', 'syslog', 'php', 'none']`

Whether Icinga Web 2 should log to 'file', 'syslog' or 'php' (web server's error log). Setting 'none' disables logging.

##### <a name="-icingaweb2--logging_file"></a>`logging_file`

Data type: `Stdlib::Absolutepath`

If 'logging' is set to 'file', this is the target log file.

##### <a name="-icingaweb2--logging_level"></a>`logging_level`

Data type: `Enum['ERROR', 'WARNING', 'INFO', 'DEBUG']`

Logging verbosity. Possible values are 'ERROR', 'WARNING', 'INFO' and 'DEBUG'.

##### <a name="-icingaweb2--logging_facility"></a>`logging_facility`

Data type: `Pattern[/user|local[0-7]/]`

Logging facility when using syslog. Possible values are 'user' or 'local0' up to 'local7'.

##### <a name="-icingaweb2--logging_application"></a>`logging_application`

Data type: `String[1]`

Logging application name when using syslog.

##### <a name="-icingaweb2--show_stacktraces"></a>`show_stacktraces`

Data type: `Boolean`

Whether to display stacktraces in the web interface or not.

##### <a name="-icingaweb2--module_path"></a>`module_path`

Data type:

```puppet
Optional[Variant[Stdlib::Absolutepath,
  Array[Stdlib::Absolutepath]]]
```

Additional path to module sources. Multiple paths must be separated by colon.

Default value: `undef`

##### <a name="-icingaweb2--theme"></a>`theme`

Data type: `String[1]`

The default theme setting. Users may override this settings.

##### <a name="-icingaweb2--theme_disabled"></a>`theme_disabled`

Data type: `Boolean`

Whether users can change themes or not.

##### <a name="-icingaweb2--manage_repos"></a>`manage_repos`

Data type: `Boolean`

When set to true this module will use the module icinga/puppet-icinga to manage repositories,
e.g. the release repo on packages.icinga.com repository by default, the EPEL repository or Backports.
For more information, see http://github.com/icinga/puppet-icinga.

##### <a name="-icingaweb2--manage_package"></a>`manage_package`

Data type: `Boolean`

If set to `false` packages aren't managed.

##### <a name="-icingaweb2--extra_packages"></a>`extra_packages`

Data type: `Optional[Array[String[1]]]`

An array of packages to install additionally.

Default value: `undef`

##### <a name="-icingaweb2--import_schema"></a>`import_schema`

Data type: `Optional[Icingaweb2::ImportSchema]`

Whether to import the MySQL schema or not. New options `mariadb` and `mysql`,
both means true. With mariadb its cli options are used for the import,
whereas with mysql its different options.

Default value: `undef`

##### <a name="-icingaweb2--db_type"></a>`db_type`

Data type: `Enum['mysql', 'pgsql']`

Database type, can be either `mysql` or `pgsql`.

##### <a name="-icingaweb2--db_resource_name"></a>`db_resource_name`

Data type: `String[1]`

Name for the icingaweb2 database resource.

##### <a name="-icingaweb2--db_host"></a>`db_host`

Data type: `Stdlib::Host`

Database hostname.

##### <a name="-icingaweb2--db_port"></a>`db_port`

Data type: `Optional[Stdlib::Port]`

Port to connect on the database host.

Default value: `undef`

##### <a name="-icingaweb2--db_name"></a>`db_name`

Data type: `String[1]`

Database name.

##### <a name="-icingaweb2--db_username"></a>`db_username`

Data type: `String[1]`

Username for database access.

##### <a name="-icingaweb2--db_password"></a>`db_password`

Data type: `Optional[Icinga::Secret]`

Password for database access.

Default value: `undef`

##### <a name="-icingaweb2--use_tls"></a>`use_tls`

Data type: `Optional[Boolean]`

Either enable or disable TLS encryption to the database. Other TLS parameters
are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icingaweb2--tls_key_file"></a>`tls_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--tls_cert_file"></a>`tls_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--tls_cacert_file"></a>`tls_cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the ca certificate. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--tls_key"></a>`tls_key`

Data type: `Optional[Icinga::Secret]`

The private key to store in spicified `tls_key_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--tls_cert"></a>`tls_cert`

Data type: `Optional[String[1]]`

The certificate to store in spicified `tls_cert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--tls_cacert"></a>`tls_cacert`

Data type: `Optional[String[1]]`

The ca certificate to store in spicified `tls_cacert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--tls_capath"></a>`tls_capath`

Data type: `Optional[Stdlib::Absolutepath]`

The file path to the directory that contains the trusted SSL CA certificates, which are stored in PEM format.
Only available for the mysql database.

Default value: `undef`

##### <a name="-icingaweb2--tls_noverify"></a>`tls_noverify`

Data type: `Optional[Boolean]`

Disable validation of the server certificate.

Default value: `undef`

##### <a name="-icingaweb2--tls_cipher"></a>`tls_cipher`

Data type: `Optional[String[1]]`

Cipher to use for the encrypted database connection.

Default value: `undef`

##### <a name="-icingaweb2--conf_user"></a>`conf_user`

Data type: `String[1]`

By default this module expects Apache2 on the server. You can change the owner of the config files with this
parameter.

##### <a name="-icingaweb2--conf_group"></a>`conf_group`

Data type: `String[1]`

Group membership of config files.

##### <a name="-icingaweb2--default_domain"></a>`default_domain`

Data type: `Optional[String[1]]`

When using domain-aware authentication, you can set a default domain here.

Default value: `undef`

##### <a name="-icingaweb2--cookie_path"></a>`cookie_path`

Data type: `Optional[Stdlib::Absolutepath]`

Path to where cookies are stored.

Default value: `undef`

##### <a name="-icingaweb2--admin_role"></a>`admin_role`

Data type: `Variant[Icingaweb2::AdminRole, Boolean[false]]`

Manage a role for admin access.

##### <a name="-icingaweb2--default_admin_username"></a>`default_admin_username`

Data type: `String[1]`

Default username for initial admin access. This parameter is only used
if `import_schema` is set to `true` and only during the import itself.

##### <a name="-icingaweb2--default_admin_password"></a>`default_admin_password`

Data type: `Icinga::Secret`

Default password for initial admin access. This parameter is only used
if `import_schema` is set to `true` and only during the import itself.

##### <a name="-icingaweb2--resources"></a>`resources`

Data type: `Hash[String[1], Hash[String[1], Any]]`

Additional resources. Option `type` has to be set as hash key. Type of `ldap`
declares a define resource of `icingaweb2::resource::ldap`, a type of `mysql`, `pgsql`,

##### <a name="-icingaweb2--default_auth_backend"></a>`default_auth_backend`

Data type: `Variant[String[1], Boolean[false]]`

Name of the user and group backend authentication of the icingaweb2 resource.
If set to `false` the default authentication method is deactivated.

##### <a name="-icingaweb2--user_backends"></a>`user_backends`

Data type: `Hash[String[1], Hash[String[1], Any]]`

Additional user backends for access control. See `icingaweb2::config::authmethod`.

##### <a name="-icingaweb2--group_backends"></a>`group_backends`

Data type: `Hash[String[1], Hash[String[1], Any]]`

Additional group backends for access control. See `icingaweb2::config::groupbackend`.

### <a name="icingaweb2--globals"></a>`icingaweb2::globals`

This class loads the default parameters by doing a hiera lookup.

* **Note** This parameters depend on the os plattform. Changes maybe will break the functional capability of the supported plattforms and versions. Please only do changes when you know what you're doing.

#### Parameters

The following parameters are available in the `icingaweb2::globals` class:

* [`package_name`](#-icingaweb2--globals--package_name)
* [`conf_dir`](#-icingaweb2--globals--conf_dir)
* [`state_dir`](#-icingaweb2--globals--state_dir)
* [`data_dir`](#-icingaweb2--globals--data_dir)
* [`role_replace`](#-icingaweb2--globals--role_replace)
* [`comp_db_schema_dir`](#-icingaweb2--globals--comp_db_schema_dir)
* [`default_module_path`](#-icingaweb2--globals--default_module_path)
* [`mysql_db_schema`](#-icingaweb2--globals--mysql_db_schema)
* [`pgsql_db_schema`](#-icingaweb2--globals--pgsql_db_schema)
* [`mysql_vspheredb_schema`](#-icingaweb2--globals--mysql_vspheredb_schema)
* [`pgsql_vspheredb_schema`](#-icingaweb2--globals--pgsql_vspheredb_schema)
* [`mysql_reporting_schema`](#-icingaweb2--globals--mysql_reporting_schema)
* [`pgsql_reporting_schema`](#-icingaweb2--globals--pgsql_reporting_schema)
* [`mysql_idoreports_slaperiods`](#-icingaweb2--globals--mysql_idoreports_slaperiods)
* [`mysql_idoreports_sla_percent`](#-icingaweb2--globals--mysql_idoreports_sla_percent)
* [`pgsql_idoreports_slaperiods`](#-icingaweb2--globals--pgsql_idoreports_slaperiods)
* [`pgsql_idoreports_sla_percent`](#-icingaweb2--globals--pgsql_idoreports_sla_percent)
* [`mysql_x509_schema`](#-icingaweb2--globals--mysql_x509_schema)
* [`pgsql_x509_schema`](#-icingaweb2--globals--pgsql_x509_schema)
* [`gettext_package_name`](#-icingaweb2--globals--gettext_package_name)
* [`icingacli_bin`](#-icingaweb2--globals--icingacli_bin)

##### <a name="-icingaweb2--globals--package_name"></a>`package_name`

Data type: `String[1]`

Package to install.

##### <a name="-icingaweb2--globals--conf_dir"></a>`conf_dir`

Data type: `Stdlib::Absolutepath`

Path to the config files.

##### <a name="-icingaweb2--globals--state_dir"></a>`state_dir`

Data type: `Stdlib::Absolutepath`

Path to variable application data.

##### <a name="-icingaweb2--globals--data_dir"></a>`data_dir`

Data type: `Stdlib::Absolutepath`

Location of PHP data files.

##### <a name="-icingaweb2--globals--role_replace"></a>`role_replace`

Data type: `Boolean`

Specifies whether to overwrite the roles.ini file if it already exists.

##### <a name="-icingaweb2--globals--comp_db_schema_dir"></a>`comp_db_schema_dir`

Data type: `Stdlib::Absolutepath`

For compatibility, since in Icinga Web 2 2.11.4 the schema files have been moved.

##### <a name="-icingaweb2--globals--default_module_path"></a>`default_module_path`

Data type: `Stdlib::Absolutepath`

Location of the modules.

##### <a name="-icingaweb2--globals--mysql_db_schema"></a>`mysql_db_schema`

Data type: `Stdlib::Absolutepath`

Location of the database schema for MySQL/MariaDB.

##### <a name="-icingaweb2--globals--pgsql_db_schema"></a>`pgsql_db_schema`

Data type: `Stdlib::Absolutepath`

Location of the database schema for PostgreSQL.

##### <a name="-icingaweb2--globals--mysql_vspheredb_schema"></a>`mysql_vspheredb_schema`

Data type: `Stdlib::Absolutepath`

Location of the vspheredb database schema for MySQL/MariaDB.

##### <a name="-icingaweb2--globals--pgsql_vspheredb_schema"></a>`pgsql_vspheredb_schema`

Data type: `Stdlib::Absolutepath`

Location of the vspheredb database schema for PostgreSQL.

##### <a name="-icingaweb2--globals--mysql_reporting_schema"></a>`mysql_reporting_schema`

Data type: `Stdlib::Absolutepath`

Location of the reporting database schema for MySQL/MariaDB.

##### <a name="-icingaweb2--globals--pgsql_reporting_schema"></a>`pgsql_reporting_schema`

Data type: `Stdlib::Absolutepath`

Location of the reporting database schema for PostgreSQL.

##### <a name="-icingaweb2--globals--mysql_idoreports_slaperiods"></a>`mysql_idoreports_slaperiods`

Data type: `Stdlib::Absolutepath`

Location of the slaperiods database extension for MySQL.

##### <a name="-icingaweb2--globals--mysql_idoreports_sla_percent"></a>`mysql_idoreports_sla_percent`

Data type: `Stdlib::Absolutepath`

Location of the get_sla_ok_percent database extension for MySQL.

##### <a name="-icingaweb2--globals--pgsql_idoreports_slaperiods"></a>`pgsql_idoreports_slaperiods`

Data type: `Stdlib::Absolutepath`

Location of the slaperiods database extension for PostgreSQL.

##### <a name="-icingaweb2--globals--pgsql_idoreports_sla_percent"></a>`pgsql_idoreports_sla_percent`

Data type: `Stdlib::Absolutepath`

Location of the get_sla_ok_percent database extension for PostgreSQL.

##### <a name="-icingaweb2--globals--mysql_x509_schema"></a>`mysql_x509_schema`

Data type: `Stdlib::Absolutepath`

Location of the x509 database schema for MySQL/MariaDB.

##### <a name="-icingaweb2--globals--pgsql_x509_schema"></a>`pgsql_x509_schema`

Data type: `Stdlib::Absolutepath`

Location of the x509 database schema for PostgreSQL.

##### <a name="-icingaweb2--globals--gettext_package_name"></a>`gettext_package_name`

Data type: `String[1]`

Package name `gettext` tool belongs to.

##### <a name="-icingaweb2--globals--icingacli_bin"></a>`icingacli_bin`

Data type: `Stdlib::Absolutepath`

Path to `icingacli' comand line tool.

### <a name="icingaweb2--module--audit"></a>`icingaweb2::module::audit`

Installs and enables the audit  module.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed.

#### Examples

##### 

```puppet
class { 'icingaweb2::module::audit':
  git_revision => 'v1.0.2',
  log_type     => 'syslog',
  log_facility => 'authpriv',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::audit` class:

* [`ensure`](#-icingaweb2--module--audit--ensure)
* [`module_dir`](#-icingaweb2--module--audit--module_dir)
* [`git_repository`](#-icingaweb2--module--audit--git_repository)
* [`git_revision`](#-icingaweb2--module--audit--git_revision)
* [`install_method`](#-icingaweb2--module--audit--install_method)
* [`package_name`](#-icingaweb2--module--audit--package_name)
* [`log_type`](#-icingaweb2--module--audit--log_type)
* [`log_file`](#-icingaweb2--module--audit--log_file)
* [`log_ident`](#-icingaweb2--module--audit--log_ident)
* [`log_facility`](#-icingaweb2--module--audit--log_facility)
* [`stream_format`](#-icingaweb2--module--audit--stream_format)
* [`stream_file`](#-icingaweb2--module--audit--stream_file)

##### <a name="-icingaweb2--module--audit--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--audit--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/audit"`

##### <a name="-icingaweb2--module--audit--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--audit--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v1.0.2`.

Default value: `undef`

##### <a name="-icingaweb2--module--audit--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--audit--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--audit--log_type"></a>`log_type`

Data type: `Enum['file', 'syslog', 'none']`

Logging type to use.

##### <a name="-icingaweb2--module--audit--log_file"></a>`log_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the log file. Only valid if `log_type` is set to `file`.

Default value: `undef`

##### <a name="-icingaweb2--module--audit--log_ident"></a>`log_ident`

Data type: `Optional[String]`

Logging prefix ident. Only valid if `log_type` is set to `syslog`.

Default value: `undef`

##### <a name="-icingaweb2--module--audit--log_facility"></a>`log_facility`

Data type:

```puppet
Variant[
    Enum['auth', 'user', 'authpriv'],
    Pattern[/^local[0-7]$/]
  ]
```

Facility to log to. Only valid if `log_type` is set to `syslog`.

##### <a name="-icingaweb2--module--audit--stream_format"></a>`stream_format`

Data type: `Enum['json', 'none']`

Set to `json` to stream in JSON format. Disabled by setting to `none`.

##### <a name="-icingaweb2--module--audit--stream_file"></a>`stream_file`

Data type: `Optional[Stdlib::Absolutepath]`

Path to the stream destination.

Default value: `undef`

### <a name="icingaweb2--module--businessprocess"></a>`icingaweb2::module::businessprocess`

Installs and enables the businessprocess module.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### 

```puppet
class { 'icingaweb2::module::businessprocess':
  git_revision => 'v2.1.0'
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::businessprocess` class:

* [`ensure`](#-icingaweb2--module--businessprocess--ensure)
* [`module_dir`](#-icingaweb2--module--businessprocess--module_dir)
* [`git_repository`](#-icingaweb2--module--businessprocess--git_repository)
* [`git_revision`](#-icingaweb2--module--businessprocess--git_revision)
* [`install_method`](#-icingaweb2--module--businessprocess--install_method)
* [`package_name`](#-icingaweb2--module--businessprocess--package_name)

##### <a name="-icingaweb2--module--businessprocess--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--businessprocess--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/businessprocess"`

##### <a name="-icingaweb2--module--businessprocess--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--businessprocess--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v2.1.0`.

Default value: `undef`

##### <a name="-icingaweb2--module--businessprocess--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--businessprocess--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

### <a name="icingaweb2--module--cube"></a>`icingaweb2::module::cube`

Installs and enables the cube module.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### 

```puppet
class { 'icingaweb2::module::cube':
  git_revision => 'v1.0.0'
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::cube` class:

* [`ensure`](#-icingaweb2--module--cube--ensure)
* [`module_dir`](#-icingaweb2--module--cube--module_dir)
* [`git_repository`](#-icingaweb2--module--cube--git_repository)
* [`git_revision`](#-icingaweb2--module--cube--git_revision)
* [`install_method`](#-icingaweb2--module--cube--install_method)
* [`package_name`](#-icingaweb2--module--cube--package_name)

##### <a name="-icingaweb2--module--cube--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--cube--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/cube"`

##### <a name="-icingaweb2--module--cube--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--cube--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v1.0.0`.

Default value: `undef`

##### <a name="-icingaweb2--module--cube--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--cube--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

### <a name="icingaweb2--module--director"></a>`icingaweb2::module::director`

Install and configure the director module.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### 

```puppet
class { 'icingaweb2::module::director':
  git_revision  => 'v1.7.2',
  db_host       => 'localhost',
  db_name       => 'director',
  db_username   => 'director',
  db_password   => 'supersecret',
  import_schema => true,
  kickstart     => true,
  endpoint      => 'puppet-icingaweb2.localdomain',
  api_username  => 'director',
  api_password  => 'supersecret',
  require       => Mysql::Db['director']
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::director` class:

* [`ensure`](#-icingaweb2--module--director--ensure)
* [`module_dir`](#-icingaweb2--module--director--module_dir)
* [`git_repository`](#-icingaweb2--module--director--git_repository)
* [`git_revision`](#-icingaweb2--module--director--git_revision)
* [`install_method`](#-icingaweb2--module--director--install_method)
* [`package_name`](#-icingaweb2--module--director--package_name)
* [`db_type`](#-icingaweb2--module--director--db_type)
* [`db_resource_name`](#-icingaweb2--module--director--db_resource_name)
* [`db_host`](#-icingaweb2--module--director--db_host)
* [`db_port`](#-icingaweb2--module--director--db_port)
* [`db_name`](#-icingaweb2--module--director--db_name)
* [`db_username`](#-icingaweb2--module--director--db_username)
* [`db_password`](#-icingaweb2--module--director--db_password)
* [`db_charset`](#-icingaweb2--module--director--db_charset)
* [`use_tls`](#-icingaweb2--module--director--use_tls)
* [`tls_key_file`](#-icingaweb2--module--director--tls_key_file)
* [`tls_cert_file`](#-icingaweb2--module--director--tls_cert_file)
* [`tls_cacert_file`](#-icingaweb2--module--director--tls_cacert_file)
* [`tls_key`](#-icingaweb2--module--director--tls_key)
* [`tls_cert`](#-icingaweb2--module--director--tls_cert)
* [`tls_cacert`](#-icingaweb2--module--director--tls_cacert)
* [`tls_capath`](#-icingaweb2--module--director--tls_capath)
* [`tls_noverify`](#-icingaweb2--module--director--tls_noverify)
* [`tls_cipher`](#-icingaweb2--module--director--tls_cipher)
* [`import_schema`](#-icingaweb2--module--director--import_schema)
* [`kickstart`](#-icingaweb2--module--director--kickstart)
* [`endpoint`](#-icingaweb2--module--director--endpoint)
* [`api_host`](#-icingaweb2--module--director--api_host)
* [`api_port`](#-icingaweb2--module--director--api_port)
* [`api_username`](#-icingaweb2--module--director--api_username)
* [`api_password`](#-icingaweb2--module--director--api_password)
* [`manage_service`](#-icingaweb2--module--director--manage_service)
* [`service_ensure`](#-icingaweb2--module--director--service_ensure)
* [`service_enable`](#-icingaweb2--module--director--service_enable)
* [`service_user`](#-icingaweb2--module--director--service_user)

##### <a name="-icingaweb2--module--director--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--director--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/director"`

##### <a name="-icingaweb2--module--director--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--director--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v1.3.2`.

Default value: `undef`

##### <a name="-icingaweb2--module--director--install_method"></a>`install_method`

Data type: `Enum['git', 'package', 'none']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--director--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--director--db_type"></a>`db_type`

Data type: `Enum['mysql', 'pgsql']`

Type of your database. Either `mysql` or `pgsql`.

##### <a name="-icingaweb2--module--director--db_resource_name"></a>`db_resource_name`

Data type: `String[1]`

Name for the director database resource.

##### <a name="-icingaweb2--module--director--db_host"></a>`db_host`

Data type: `Stdlib::Host`

Hostname of the database.

##### <a name="-icingaweb2--module--director--db_port"></a>`db_port`

Data type: `Optional[Stdlib::Port]`

Port of the database.

Default value: `undef`

##### <a name="-icingaweb2--module--director--db_name"></a>`db_name`

Data type: `String[1]`

Name of the database.

##### <a name="-icingaweb2--module--director--db_username"></a>`db_username`

Data type: `String[1]`

Username for DB connection.

##### <a name="-icingaweb2--module--director--db_password"></a>`db_password`

Data type: `Optional[Icinga::Secret]`

Password for DB connection.

Default value: `undef`

##### <a name="-icingaweb2--module--director--db_charset"></a>`db_charset`

Data type: `Optional[String[1]]`

Character set to use for the database.

Default value: `undef`

##### <a name="-icingaweb2--module--director--use_tls"></a>`use_tls`

Data type: `Optional[Boolean]`

Either enable or disable TLS encryption to the database. Other TLS parameters
are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icingaweb2--module--director--tls_key_file"></a>`tls_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--director--tls_cert_file"></a>`tls_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--director--tls_cacert_file"></a>`tls_cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the ca certificate. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--director--tls_key"></a>`tls_key`

Data type: `Optional[Icinga::Secret]`

The private key to store in spicified `tls_key_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--director--tls_cert"></a>`tls_cert`

Data type: `Optional[String[1]]`

The certificate to store in spicified `tls_cert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--director--tls_cacert"></a>`tls_cacert`

Data type: `Optional[String[1]]`

The ca certificate to store in spicified `tls_cacert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--director--tls_capath"></a>`tls_capath`

Data type: `Optional[Stdlib::Absolutepath]`

The file path to the directory that contains the trusted SSL CA certificates, which are stored in PEM format.
Only available for the mysql database.

Default value: `undef`

##### <a name="-icingaweb2--module--director--tls_noverify"></a>`tls_noverify`

Data type: `Optional[Boolean]`

Disable validation of the server certificate.

Default value: `undef`

##### <a name="-icingaweb2--module--director--tls_cipher"></a>`tls_cipher`

Data type: `Optional[String[1]]`

Cipher to use for the encrypted database connection.

Default value: `undef`

##### <a name="-icingaweb2--module--director--import_schema"></a>`import_schema`

Data type: `Optional[Boolean]`

Import database schema.

Default value: `undef`

##### <a name="-icingaweb2--module--director--kickstart"></a>`kickstart`

Data type: `Boolean`

Run kickstart command after database migration. This requires `import_schema` to be `true`.

##### <a name="-icingaweb2--module--director--endpoint"></a>`endpoint`

Data type: `Optional[String[1]]`

Endpoint object name of Icinga 2 API. This setting is only valid if `kickstart` is `true`.

Default value: `undef`

##### <a name="-icingaweb2--module--director--api_host"></a>`api_host`

Data type: `Stdlib::Host`

Icinga 2 API hostname. This setting is only valid if `kickstart` is `true`.

##### <a name="-icingaweb2--module--director--api_port"></a>`api_port`

Data type: `Stdlib::Port`

Icinga 2 API port. This setting is only valid if `kickstart` is `true`.

##### <a name="-icingaweb2--module--director--api_username"></a>`api_username`

Data type: `Optional[String[1]]`

Icinga 2 API username. This setting is only valid if `kickstart` is `true`.

Default value: `undef`

##### <a name="-icingaweb2--module--director--api_password"></a>`api_password`

Data type: `Optional[Icinga::Secret]`

Icinga 2 API password. This setting is only valid if `kickstart` is `true`.

Default value: `undef`

##### <a name="-icingaweb2--module--director--manage_service"></a>`manage_service`

Data type: `Boolean`

If set to true the service (daemon) is managed.

##### <a name="-icingaweb2--module--director--service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

Wether the service is `running` or `stopped`.

##### <a name="-icingaweb2--module--director--service_enable"></a>`service_enable`

Data type: `Boolean`

Whether the service should be started at boot time.

##### <a name="-icingaweb2--module--director--service_user"></a>`service_user`

Data type: `String[1]`

The user as which the service is running. Only valid if `install_method` is set to `git`.

### <a name="icingaweb2--module--doc"></a>`icingaweb2::module::doc`

The doc module provides an interface to the Icinga 2 and Icinga Web 2 documentation.

#### Parameters

The following parameters are available in the `icingaweb2::module::doc` class:

* [`ensure`](#-icingaweb2--module--doc--ensure)

##### <a name="-icingaweb2--module--doc--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module. Defaults to `present`

### <a name="icingaweb2--module--elasticsearch"></a>`icingaweb2::module::elasticsearch`

The Elasticsearch module displays events from data stored in Elasticsearch.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### 

```puppet
class { 'icingaweb2::module::elasticsearch':
  git_revision => 'v0.9.0',
  instances    => {
    'elastic'  => {
      uri      => 'http://localhost:9200',
      user     => 'foo',
      password => 'bar',
    }
  },
  eventtypes   => {
    'filebeat' => {
      instance => 'elastic',
      index    => 'filebeat-*',
      filter   => 'beat.hostname={host.name}',
      fields   => 'input_type, source, message',
    }
  }
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::elasticsearch` class:

* [`ensure`](#-icingaweb2--module--elasticsearch--ensure)
* [`module_dir`](#-icingaweb2--module--elasticsearch--module_dir)
* [`git_repository`](#-icingaweb2--module--elasticsearch--git_repository)
* [`install_method`](#-icingaweb2--module--elasticsearch--install_method)
* [`package_name`](#-icingaweb2--module--elasticsearch--package_name)
* [`git_revision`](#-icingaweb2--module--elasticsearch--git_revision)
* [`instances`](#-icingaweb2--module--elasticsearch--instances)
* [`eventtypes`](#-icingaweb2--module--elasticsearch--eventtypes)

##### <a name="-icingaweb2--module--elasticsearch--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--elasticsearch--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/elasticsearch"`

##### <a name="-icingaweb2--module--elasticsearch--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--elasticsearch--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--elasticsearch--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--elasticsearch--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v1.3.2`.

Default value: `undef`

##### <a name="-icingaweb2--module--elasticsearch--instances"></a>`instances`

Data type: `Optional[Hash]`

A hash that configures one or more Elasticsearch instances that this module connects to. The defined type
`icingaweb2::module::elasticsearch::instance` is used to create the instance configuration.

Default value: `undef`

##### <a name="-icingaweb2--module--elasticsearch--eventtypes"></a>`eventtypes`

Data type: `Optional[Hash]`

A hash oft ypes of events that should be displayed. Event types are always connected to instances. The defined type
`icingaweb2::module::elasticsearch::eventtype` is used to create the event types.

Default value: `undef`

### <a name="icingaweb2--module--fileshipper"></a>`icingaweb2::module::fileshipper`

@example:
  class { 'icingaweb2::module::fileshipper':
    git_revision => 'v1.0.1',
    base_directories => {
      temp => '/var/lib/fileshipper'
    },
    directories      => {
      'test' => {
        'source'     => '/var/lib/fileshipper/source',
        'target'     => '/var/lib/fileshipper/target',
      }
    }
  }

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Parameters

The following parameters are available in the `icingaweb2::module::fileshipper` class:

* [`ensure`](#-icingaweb2--module--fileshipper--ensure)
* [`module_dir`](#-icingaweb2--module--fileshipper--module_dir)
* [`git_repository`](#-icingaweb2--module--fileshipper--git_repository)
* [`install_method`](#-icingaweb2--module--fileshipper--install_method)
* [`package_name`](#-icingaweb2--module--fileshipper--package_name)
* [`git_revision`](#-icingaweb2--module--fileshipper--git_revision)
* [`base_directories`](#-icingaweb2--module--fileshipper--base_directories)
* [`directories`](#-icingaweb2--module--fileshipper--directories)

##### <a name="-icingaweb2--module--fileshipper--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enables or disables module.

##### <a name="-icingaweb2--module--fileshipper--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/fileshipper"`

##### <a name="-icingaweb2--module--fileshipper--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--fileshipper--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--fileshipper--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--fileshipper--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v1.3.2`.

Default value: `undef`

##### <a name="-icingaweb2--module--fileshipper--base_directories"></a>`base_directories`

Data type: `Hash`

Hash of base directories. These directories can later be selected in the import source (Director).

##### <a name="-icingaweb2--module--fileshipper--directories"></a>`directories`

Data type: `Hash`

Deploy plain Icinga 2 configuration files through the Director to your Icinga 2 master.

### <a name="icingaweb2--module--generictts"></a>`icingaweb2::module::generictts`

Installs and enables the generictts module.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### 

```puppet
class { 'icingaweb2::module::generictts':
  git_revision  => 'v2.0.0',
  ticketsystems => {
    'my-ticket-system' => {
      pattern => '/#([0-9]{4,6})/',
      url     => 'https://my.ticket.system/tickets/id=$1',
    },
  },
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::generictts` class:

* [`ensure`](#-icingaweb2--module--generictts--ensure)
* [`module_dir`](#-icingaweb2--module--generictts--module_dir)
* [`git_repository`](#-icingaweb2--module--generictts--git_repository)
* [`git_revision`](#-icingaweb2--module--generictts--git_revision)
* [`install_method`](#-icingaweb2--module--generictts--install_method)
* [`package_name`](#-icingaweb2--module--generictts--package_name)
* [`ticketsystems`](#-icingaweb2--module--generictts--ticketsystems)

##### <a name="-icingaweb2--module--generictts--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--generictts--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/generictts"`

##### <a name="-icingaweb2--module--generictts--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--generictts--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v2.0.0`.

Default value: `undef`

##### <a name="-icingaweb2--module--generictts--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--generictts--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--generictts--ticketsystems"></a>`ticketsystems`

Data type: `Hash`

A hash of ticketsystems. The hash expects a `patten` and a `url` for each ticketsystem.
The regex pattern is to match the ticket ID, eg. `/#([0-9]{4,6})/`. Place the ticket ID
in the URL, eg. `https://my.ticket.system/tickets/id=$1`.

### <a name="icingaweb2--module--graphite"></a>`icingaweb2::module::graphite`

The Graphite module draws graphs out of time series data stored in Graphite.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### 

```puppet
class { 'icingaweb2::module::graphite':
  git_revision => 'v0.9.0',
  url          => 'https://localhost:8080'
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::graphite` class:

* [`ensure`](#-icingaweb2--module--graphite--ensure)
* [`module_dir`](#-icingaweb2--module--graphite--module_dir)
* [`git_repository`](#-icingaweb2--module--graphite--git_repository)
* [`git_revision`](#-icingaweb2--module--graphite--git_revision)
* [`install_method`](#-icingaweb2--module--graphite--install_method)
* [`package_name`](#-icingaweb2--module--graphite--package_name)
* [`url`](#-icingaweb2--module--graphite--url)
* [`insecure`](#-icingaweb2--module--graphite--insecure)
* [`user`](#-icingaweb2--module--graphite--user)
* [`password`](#-icingaweb2--module--graphite--password)
* [`graphite_writer_host_name_template`](#-icingaweb2--module--graphite--graphite_writer_host_name_template)
* [`graphite_writer_service_name_template`](#-icingaweb2--module--graphite--graphite_writer_service_name_template)
* [`customvar_obscured_check_command`](#-icingaweb2--module--graphite--customvar_obscured_check_command)
* [`default_time_range_unit`](#-icingaweb2--module--graphite--default_time_range_unit)
* [`default_time_range`](#-icingaweb2--module--graphite--default_time_range)
* [`disable_no_graphs`](#-icingaweb2--module--graphite--disable_no_graphs)

##### <a name="-icingaweb2--module--graphite--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enables or disables module.

##### <a name="-icingaweb2--module--graphite--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/graphite"`

##### <a name="-icingaweb2--module--graphite--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--graphite--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v1.3.2`.

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--graphite--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--graphite--url"></a>`url`

Data type: `Optional[Stdlib::HTTPUrl]`

URL to your Graphite Web/API.

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--insecure"></a>`insecure`

Data type: `Optional[Boolean]`

Do not verify the TLS certificate.

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--user"></a>`user`

Data type: `Optional[String[1]]`

A user with access to your Graphite Web via HTTP basic authentication.

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--password"></a>`password`

Data type: `Optional[Icinga::Secret]`

The users password.

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--graphite_writer_host_name_template"></a>`graphite_writer_host_name_template`

Data type: `Optional[String[1]]`

The value of your Icinga 2 GraphiteWriter's attribute `host_name_template` (if specified).

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--graphite_writer_service_name_template"></a>`graphite_writer_service_name_template`

Data type: `Optional[String[1]]`

The value of your icinga 2 GraphiteWriter's attribute `service_name_template` (if specified).

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--customvar_obscured_check_command"></a>`customvar_obscured_check_command`

Data type: `Optional[String[1]]`

The Icinga custom variable with the `actual` check command obscured by e.g. check_by_ssh.

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--default_time_range_unit"></a>`default_time_range_unit`

Data type:

```puppet
Optional[Enum[
      'minutes', 'hours', 'days',
      'weeks', 'months', 'years'
  ]]
```

Set unit for the time range.

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--default_time_range"></a>`default_time_range`

Data type: `Optional[Integer[1]]`

Set the displayed time range.

Default value: `undef`

##### <a name="-icingaweb2--module--graphite--disable_no_graphs"></a>`disable_no_graphs`

Data type: `Optional[Boolean]`

Do not display empty graphs.

Default value: `undef`

### <a name="icingaweb2--module--icingadb"></a>`icingaweb2::module::icingadb`

Manages the icingadb module. This module is still optional at the moment.

* **Note** At first have a look at the [IcingaDB module documentation](https://icinga.com/docs/icinga-db/latest/doc/01-About/).

#### Parameters

The following parameters are available in the `icingaweb2::module::icingadb` class:

* [`ensure`](#-icingaweb2--module--icingadb--ensure)
* [`package_name`](#-icingaweb2--module--icingadb--package_name)
* [`db_type`](#-icingaweb2--module--icingadb--db_type)
* [`db_resource_name`](#-icingaweb2--module--icingadb--db_resource_name)
* [`db_host`](#-icingaweb2--module--icingadb--db_host)
* [`db_port`](#-icingaweb2--module--icingadb--db_port)
* [`db_name`](#-icingaweb2--module--icingadb--db_name)
* [`db_username`](#-icingaweb2--module--icingadb--db_username)
* [`db_password`](#-icingaweb2--module--icingadb--db_password)
* [`db_charset`](#-icingaweb2--module--icingadb--db_charset)
* [`db_use_tls`](#-icingaweb2--module--icingadb--db_use_tls)
* [`db_tls_cert_file`](#-icingaweb2--module--icingadb--db_tls_cert_file)
* [`db_tls_key_file`](#-icingaweb2--module--icingadb--db_tls_key_file)
* [`db_tls_cacert_file`](#-icingaweb2--module--icingadb--db_tls_cacert_file)
* [`db_tls_cert`](#-icingaweb2--module--icingadb--db_tls_cert)
* [`db_tls_key`](#-icingaweb2--module--icingadb--db_tls_key)
* [`db_tls_cacert`](#-icingaweb2--module--icingadb--db_tls_cacert)
* [`db_tls_capath`](#-icingaweb2--module--icingadb--db_tls_capath)
* [`db_tls_noverify`](#-icingaweb2--module--icingadb--db_tls_noverify)
* [`db_tls_cipher`](#-icingaweb2--module--icingadb--db_tls_cipher)
* [`redis_host`](#-icingaweb2--module--icingadb--redis_host)
* [`redis_port`](#-icingaweb2--module--icingadb--redis_port)
* [`redis_password`](#-icingaweb2--module--icingadb--redis_password)
* [`redis_primary_host`](#-icingaweb2--module--icingadb--redis_primary_host)
* [`redis_primary_port`](#-icingaweb2--module--icingadb--redis_primary_port)
* [`redis_primary_password`](#-icingaweb2--module--icingadb--redis_primary_password)
* [`redis_secondary_host`](#-icingaweb2--module--icingadb--redis_secondary_host)
* [`redis_secondary_port`](#-icingaweb2--module--icingadb--redis_secondary_port)
* [`redis_secondary_password`](#-icingaweb2--module--icingadb--redis_secondary_password)
* [`redis_use_tls`](#-icingaweb2--module--icingadb--redis_use_tls)
* [`redis_tls_cert`](#-icingaweb2--module--icingadb--redis_tls_cert)
* [`redis_tls_key`](#-icingaweb2--module--icingadb--redis_tls_key)
* [`redis_tls_cacert`](#-icingaweb2--module--icingadb--redis_tls_cacert)
* [`redis_tls_cert_file`](#-icingaweb2--module--icingadb--redis_tls_cert_file)
* [`redis_tls_key_file`](#-icingaweb2--module--icingadb--redis_tls_key_file)
* [`redis_tls_cacert_file`](#-icingaweb2--module--icingadb--redis_tls_cacert_file)
* [`settings`](#-icingaweb2--module--icingadb--settings)
* [`commandtransports`](#-icingaweb2--module--icingadb--commandtransports)

##### <a name="-icingaweb2--module--icingadb--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--icingadb--package_name"></a>`package_name`

Data type: `String[1]`

IicngaDB-Web module package name.

##### <a name="-icingaweb2--module--icingadb--db_type"></a>`db_type`

Data type: `Enum['mysql', 'pgsql']`

Type of your IDO database. Either `mysql` or `pgsql`.

##### <a name="-icingaweb2--module--icingadb--db_resource_name"></a>`db_resource_name`

Data type: `String[1]`

Name for the icingadb database resource.

##### <a name="-icingaweb2--module--icingadb--db_host"></a>`db_host`

Data type: `Stdlib::Host`

Hostname of the IcingaDB database.

##### <a name="-icingaweb2--module--icingadb--db_port"></a>`db_port`

Data type: `Optional[Stdlib::Port]`

Port of the IcingaDB database.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_name"></a>`db_name`

Data type: `String[1]`

Name of the IcingaDB database.

##### <a name="-icingaweb2--module--icingadb--db_username"></a>`db_username`

Data type: `String[1]`

Username for IcingaDB database connection.

##### <a name="-icingaweb2--module--icingadb--db_password"></a>`db_password`

Data type: `Optional[Icinga::Secret]`

Password for IcingaDB database connection.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_charset"></a>`db_charset`

Data type: `Optional[String[1]]`

The character set to use for the IcingaDB database connection.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_use_tls"></a>`db_use_tls`

Data type: `Optional[Boolean]`

Either enable or disable TLS encryption to the database. Other TLS parameters
are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_tls_cert_file"></a>`db_tls_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate for client authentication. Only valid if db_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_tls_key_file"></a>`db_tls_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key for client authentication. Only valid if db_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_tls_cacert_file"></a>`db_tls_cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the CA root certificate. Only valid if db_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_tls_cert"></a>`db_tls_cert`

Data type: `Optional[String]`

The client certificate in PEM format. Only valid if db_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_tls_key"></a>`db_tls_key`

Data type: `Optional[Icinga::Secret]`

The client private key in PEM format. Only valid if db_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_tls_cacert"></a>`db_tls_cacert`

Data type: `Optional[String[1]]`

The CA root certificate in PEM format. Only valid if db_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_tls_capath"></a>`db_tls_capath`

Data type: `Optional[Stdlib::Absolutepath]`

The file path to the directory that contains the trusted SSL CA certificates, which are stored in PEM format.
Only available for the mysql database.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_tls_noverify"></a>`db_tls_noverify`

Data type: `Optional[Boolean]`

Disable validation of the server certificate.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--db_tls_cipher"></a>`db_tls_cipher`

Data type: `Optional[String[1]]`

Cipher to use for the encrypted database connection.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_host"></a>`redis_host`

Data type: `Stdlib::Host`

Redis host to connect.

##### <a name="-icingaweb2--module--icingadb--redis_port"></a>`redis_port`

Data type: `Optional[Stdlib::Port]`

Connect `redis_host` om this port.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_password"></a>`redis_password`

Data type: `Optional[Icinga::Secret]`

Password for Redis connection.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_primary_host"></a>`redis_primary_host`

Data type: `Stdlib::Host`

Alternative parameter to use for `redis_host`. Useful for high availability environments.

Default value: `$redis_host`

##### <a name="-icingaweb2--module--icingadb--redis_primary_port"></a>`redis_primary_port`

Data type: `Optional[Stdlib::Port]`

Alternative parameter to use for `redis_port`. Useful for high availability environments.

Default value: `$redis_port`

##### <a name="-icingaweb2--module--icingadb--redis_primary_password"></a>`redis_primary_password`

Data type: `Optional[Icinga::Secret]`

Alternative parameter to use for `redis_passwod`. Useful for high availability environments.

Default value: `$redis_password`

##### <a name="-icingaweb2--module--icingadb--redis_secondary_host"></a>`redis_secondary_host`

Data type: `Optional[Stdlib::Host]`

Fallback Redis host to connect if the first one fails.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_secondary_port"></a>`redis_secondary_port`

Data type: `Optional[Stdlib::Port]`

Port to connect on the fallback Redis server.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_secondary_password"></a>`redis_secondary_password`

Data type: `Optional[Icinga::Secret]`

Password for the second Redis server.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_use_tls"></a>`redis_use_tls`

Data type: `Optional[Boolean]`

Use tls encrypt connection for Redis.
All Credentials are applied for both connections in a high availability environments.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_tls_cert"></a>`redis_tls_cert`

Data type: `Optional[String[1]]`

Client certificate in PEM format to authenticate to Redis.
Only valid if redis_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_tls_key"></a>`redis_tls_key`

Data type: `Optional[Icinga::Secret]`

Client private key in PEM format. Only valid if redis_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_tls_cacert"></a>`redis_tls_cacert`

Data type: `Optional[String[1]]`

The CA certificate in PEM format. Only valid if redis_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_tls_cert_file"></a>`redis_tls_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the client certificate. Only valid if redis_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_tls_key_file"></a>`redis_tls_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key. Only valid if redis_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--redis_tls_cacert_file"></a>`redis_tls_cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the CA certificate. Only valid if redis_use_tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--icingadb--settings"></a>`settings`

Data type: `Hash[String[1], Any]`

General configuration of module icingadb.
See official Icinga [documentation](https://icinga.com/docs/icinga-web/latest/modules/monitoring/doc/03-Configuration)

##### <a name="-icingaweb2--module--icingadb--commandtransports"></a>`commandtransports`

Data type: `Hash[String[1], Hash]`

A hash of command transports.

### <a name="icingaweb2--module--idoreports"></a>`icingaweb2::module::idoreports`

Installs, configures and enables the idoreports module. The module is deprecated.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### 

```puppet
class { 'icingaweb2::module::idoreports':
  git_revision  => 'v0.10.0',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::idoreports` class:

* [`ensure`](#-icingaweb2--module--idoreports--ensure)
* [`module_dir`](#-icingaweb2--module--idoreports--module_dir)
* [`git_repository`](#-icingaweb2--module--idoreports--git_repository)
* [`git_revision`](#-icingaweb2--module--idoreports--git_revision)
* [`install_method`](#-icingaweb2--module--idoreports--install_method)
* [`package_name`](#-icingaweb2--module--idoreports--package_name)
* [`import_schema`](#-icingaweb2--module--idoreports--import_schema)

##### <a name="-icingaweb2--module--idoreports--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--idoreports--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/idoreports"`

##### <a name="-icingaweb2--module--idoreports--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--idoreports--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v2.1.0`.

Default value: `undef`

##### <a name="-icingaweb2--module--idoreports--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--idoreports--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--idoreports--import_schema"></a>`import_schema`

Data type: `Optional[Icingaweb2::ImportSchema]`

The IDO database needs some extensions for reorting. Whether to import the database extensions or not.
Options `mariadb` and `mysql`, both means true. With mariadb its cli options are used for the import,
whereas with mysql its different options.

Default value: `undef`

### <a name="icingaweb2--module--monitoring"></a>`icingaweb2::module::monitoring`

Requirements:
  * IDO feature in Icinga 2 (MySQL or PostgreSQL)
  * `ApiUser` object in Icinga 2 with proper permissions

  class {'icingaweb2::module::monitoring':
    ido_host        => 'localhost',
    ido_type        => 'mysql',
    ido_db_name     => 'icinga2',
    ido_db_username => 'icinga2',
    ido_db_password => 'supersecret',
    commandtransports => {
      icinga2 => {
        transport => 'api',
        username  => 'icingaweb2',
        password  => 'supersecret',
      }
    }
  }

* **Note** At first have a look at the [Monitoring module documentation](https://www.icinga.com/docs/icingaweb2/latest/modules/monitoring/doc/01-About/).

#### Examples

##### This module is mandatory for almost every setup. It connects your Icinga Web interface to the Icinga 2 core. Current and history information are queried through the IDO database. Actions such as `Check Now`, `Set Downtime` or `Acknowledge` are send to the Icinga 2 API.

```puppet

```

#### Parameters

The following parameters are available in the `icingaweb2::module::monitoring` class:

* [`ensure`](#-icingaweb2--module--monitoring--ensure)
* [`protected_customvars`](#-icingaweb2--module--monitoring--protected_customvars)
* [`ido_type`](#-icingaweb2--module--monitoring--ido_type)
* [`ido_host`](#-icingaweb2--module--monitoring--ido_host)
* [`ido_port`](#-icingaweb2--module--monitoring--ido_port)
* [`ido_resource_name`](#-icingaweb2--module--monitoring--ido_resource_name)
* [`ido_db_name`](#-icingaweb2--module--monitoring--ido_db_name)
* [`ido_db_username`](#-icingaweb2--module--monitoring--ido_db_username)
* [`ido_db_password`](#-icingaweb2--module--monitoring--ido_db_password)
* [`ido_db_charset`](#-icingaweb2--module--monitoring--ido_db_charset)
* [`use_tls`](#-icingaweb2--module--monitoring--use_tls)
* [`tls_key_file`](#-icingaweb2--module--monitoring--tls_key_file)
* [`tls_cert_file`](#-icingaweb2--module--monitoring--tls_cert_file)
* [`tls_cacert_file`](#-icingaweb2--module--monitoring--tls_cacert_file)
* [`tls_key`](#-icingaweb2--module--monitoring--tls_key)
* [`tls_cert`](#-icingaweb2--module--monitoring--tls_cert)
* [`tls_cacert`](#-icingaweb2--module--monitoring--tls_cacert)
* [`tls_capath`](#-icingaweb2--module--monitoring--tls_capath)
* [`tls_noverify`](#-icingaweb2--module--monitoring--tls_noverify)
* [`tls_cipher`](#-icingaweb2--module--monitoring--tls_cipher)
* [`settings`](#-icingaweb2--module--monitoring--settings)
* [`commandtransports`](#-icingaweb2--module--monitoring--commandtransports)

##### <a name="-icingaweb2--module--monitoring--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--monitoring--protected_customvars"></a>`protected_customvars`

Data type: `Variant[String[1], Array[String[1]]]`

Custom variables in Icinga 2 may contain sensible information. Set patterns for custom variables
that should be hidden in the web interface.

##### <a name="-icingaweb2--module--monitoring--ido_type"></a>`ido_type`

Data type: `Enum['mysql', 'pgsql']`

Type of your IDO database. Either `mysql` or `pgsql`.

##### <a name="-icingaweb2--module--monitoring--ido_host"></a>`ido_host`

Data type: `Stdlib::Host`

Hostname of the IDO database.

##### <a name="-icingaweb2--module--monitoring--ido_port"></a>`ido_port`

Data type: `Optional[Stdlib::Port]`

Port of the IDO database.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--ido_resource_name"></a>`ido_resource_name`

Data type: `String`

Resource name for the IDO database.

##### <a name="-icingaweb2--module--monitoring--ido_db_name"></a>`ido_db_name`

Data type: `String`

Name of the IDO database.

##### <a name="-icingaweb2--module--monitoring--ido_db_username"></a>`ido_db_username`

Data type: `String`

Username for IDO DB connection.

##### <a name="-icingaweb2--module--monitoring--ido_db_password"></a>`ido_db_password`

Data type: `Optional[Icinga::Secret]`

Password for IDO DB connection.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--ido_db_charset"></a>`ido_db_charset`

Data type: `Optional[String[1]]`

The character set to use for the database connection.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--use_tls"></a>`use_tls`

Data type: `Optional[Boolean]`

Either enable or disable TLS encryption to the database. Other TLS parameters
are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--tls_key_file"></a>`tls_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--tls_cert_file"></a>`tls_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--tls_cacert_file"></a>`tls_cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the ca certificate. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--tls_key"></a>`tls_key`

Data type: `Optional[Icinga::Secret]`

The private key to store in spicified `tls_key_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--tls_cert"></a>`tls_cert`

Data type: `Optional[String[1]]`

The certificate to store in spicified `tls_cert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--tls_cacert"></a>`tls_cacert`

Data type: `Optional[String[1]]`

The ca certificate to store in spicified `tls_cacert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--tls_capath"></a>`tls_capath`

Data type: `Optional[Stdlib::Absolutepath]`

The file path to the directory that contains the trusted SSL CA certificates, which are stored in PEM format.
Only available for the mysql database.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--tls_noverify"></a>`tls_noverify`

Data type: `Optional[Boolean]`

Disable validation of the server certificate.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--tls_cipher"></a>`tls_cipher`

Data type: `Optional[String[1]]`

Cipher to use for the encrypted database connection.

Default value: `undef`

##### <a name="-icingaweb2--module--monitoring--settings"></a>`settings`

Data type: `Hash[String[1], Any]`

General configuration of module monitoring.
See official Icinga [documentation](https://icinga.com/docs/icinga-web/latest/modules/monitoring/doc/03-Configuration)

##### <a name="-icingaweb2--module--monitoring--commandtransports"></a>`commandtransports`

Data type: `Hash`

A hash of command transports.

### <a name="icingaweb2--module--pdfexport"></a>`icingaweb2::module::pdfexport`

Installs, configures and enables the pdfexport module.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### 

```puppet
class { 'icingaweb2::module::pdfexport':
  git_revision  => 'v0.10.0',
  chrome_binary => '/usr/bin/chromium-browser',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::pdfexport` class:

* [`ensure`](#-icingaweb2--module--pdfexport--ensure)
* [`module_dir`](#-icingaweb2--module--pdfexport--module_dir)
* [`git_repository`](#-icingaweb2--module--pdfexport--git_repository)
* [`git_revision`](#-icingaweb2--module--pdfexport--git_revision)
* [`install_method`](#-icingaweb2--module--pdfexport--install_method)
* [`package_name`](#-icingaweb2--module--pdfexport--package_name)
* [`chrome_binary`](#-icingaweb2--module--pdfexport--chrome_binary)
* [`force_temp_storage`](#-icingaweb2--module--pdfexport--force_temp_storage)
* [`remote_host`](#-icingaweb2--module--pdfexport--remote_host)
* [`remote_port`](#-icingaweb2--module--pdfexport--remote_port)

##### <a name="-icingaweb2--module--pdfexport--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--pdfexport--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/pdfexport"`

##### <a name="-icingaweb2--module--pdfexport--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--pdfexport--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v2.1.0`.

Default value: `undef`

##### <a name="-icingaweb2--module--pdfexport--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--pdfexport--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--pdfexport--chrome_binary"></a>`chrome_binary`

Data type: `Optional[Stdlib::Absolutepath]`

Path of the chrome or Chrome/Chromium binary.

Default value: `undef`

##### <a name="-icingaweb2--module--pdfexport--force_temp_storage"></a>`force_temp_storage`

Data type: `Optional[Boolean]`

Force using of local temp storage.

Default value: `undef`

##### <a name="-icingaweb2--module--pdfexport--remote_host"></a>`remote_host`

Data type: `Optional[Stdlib::Host]`

Connect a remote running Chrome/Chromium.

Default value: `undef`

##### <a name="-icingaweb2--module--pdfexport--remote_port"></a>`remote_port`

Data type: `Optional[Stdlib::Port]`

Port to connect the remote running Chrome/Chromium.

Default value: `undef`

### <a name="icingaweb2--module--puppetdb"></a>`icingaweb2::module::puppetdb`

Installs and configures the puppetdb module.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### Set up the PuppetDB module and configure two custom SSL keys:

```puppet
$certificates = {
  'pupdb1' => {
    :ssl_key => '-----BEGIN RSA PRIVATE KEY----- abc...',
    :ssl_cacert => '-----BEGIN RSA PRIVATE KEY----- def...',
   },
  'pupdb2' => {
    :ssl_key => '-----BEGIN RSA PRIVATE KEY----- zyx...',
    :ssl_cacert => '-----BEGIN RSA PRIVATE KEY----- wvur...',
  },
}

class { '::icingaweb2::module::puppetdb':
  git_revision => 'master',
  ssl          => 'none',
  certificates => $certificates,
}
```

##### Set up the PuppetDB module and configure the hosts SSL key to connect to the PuppetDB host:

```puppet
class {'::icingaweb2::module::puppetdb':
  git_revision => 'master',
  ssl          => 'puppet',
  host         => 'puppetdb.example.com',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::puppetdb` class:

* [`ensure`](#-icingaweb2--module--puppetdb--ensure)
* [`module_dir`](#-icingaweb2--module--puppetdb--module_dir)
* [`git_repository`](#-icingaweb2--module--puppetdb--git_repository)
* [`git_revision`](#-icingaweb2--module--puppetdb--git_revision)
* [`install_method`](#-icingaweb2--module--puppetdb--install_method)
* [`package_name`](#-icingaweb2--module--puppetdb--package_name)
* [`ssl`](#-icingaweb2--module--puppetdb--ssl)
* [`host`](#-icingaweb2--module--puppetdb--host)
* [`certificates`](#-icingaweb2--module--puppetdb--certificates)

##### <a name="-icingaweb2--module--puppetdb--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

##### <a name="-icingaweb2--module--puppetdb--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/puppetdb"`

##### <a name="-icingaweb2--module--puppetdb--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

Set a git repository URL.

##### <a name="-icingaweb2--module--puppetdb--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

Set either a branch or a tag name, eg. `master` or `v1.3.2`.

Default value: `undef`

##### <a name="-icingaweb2--module--puppetdb--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--puppetdb--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--puppetdb--ssl"></a>`ssl`

Data type: `Enum['none', 'puppet']`

How to set up ssl certificates. To copy certificates from the local puppet installation, use `puppet`.

##### <a name="-icingaweb2--module--puppetdb--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

Hostname of the server where PuppetDB is running. The `ssl` parameter needs to be set to `puppet`.

Default value: `undef`

##### <a name="-icingaweb2--module--puppetdb--certificates"></a>`certificates`

Data type: `Hash`

Hash with icingaweb2::module::puppetdb::certificate resources.

### <a name="icingaweb2--module--reporting"></a>`icingaweb2::module::reporting`

Installs the reporting module

#### Examples

##### 

```puppet
class { 'icingaweb2::module::reporting':
  ensure       => present,
  git_revision => 'v0.9.0',
  db_host      => 'localhost',
  db_name      => 'reporting',
  db_username  => 'reporting',
  db_password  => 'supersecret',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::reporting` class:

* [`ensure`](#-icingaweb2--module--reporting--ensure)
* [`module_dir`](#-icingaweb2--module--reporting--module_dir)
* [`git_repository`](#-icingaweb2--module--reporting--git_repository)
* [`git_revision`](#-icingaweb2--module--reporting--git_revision)
* [`install_method`](#-icingaweb2--module--reporting--install_method)
* [`package_name`](#-icingaweb2--module--reporting--package_name)
* [`db_type`](#-icingaweb2--module--reporting--db_type)
* [`db_resource_name`](#-icingaweb2--module--reporting--db_resource_name)
* [`db_host`](#-icingaweb2--module--reporting--db_host)
* [`db_port`](#-icingaweb2--module--reporting--db_port)
* [`db_name`](#-icingaweb2--module--reporting--db_name)
* [`db_username`](#-icingaweb2--module--reporting--db_username)
* [`db_password`](#-icingaweb2--module--reporting--db_password)
* [`db_charset`](#-icingaweb2--module--reporting--db_charset)
* [`use_tls`](#-icingaweb2--module--reporting--use_tls)
* [`tls_key_file`](#-icingaweb2--module--reporting--tls_key_file)
* [`tls_cert_file`](#-icingaweb2--module--reporting--tls_cert_file)
* [`tls_cacert_file`](#-icingaweb2--module--reporting--tls_cacert_file)
* [`tls_key`](#-icingaweb2--module--reporting--tls_key)
* [`tls_cert`](#-icingaweb2--module--reporting--tls_cert)
* [`tls_cacert`](#-icingaweb2--module--reporting--tls_cacert)
* [`tls_capath`](#-icingaweb2--module--reporting--tls_capath)
* [`tls_noverify`](#-icingaweb2--module--reporting--tls_noverify)
* [`tls_cipher`](#-icingaweb2--module--reporting--tls_cipher)
* [`import_schema`](#-icingaweb2--module--reporting--import_schema)
* [`mail`](#-icingaweb2--module--reporting--mail)
* [`manage_service`](#-icingaweb2--module--reporting--manage_service)
* [`service_ensure`](#-icingaweb2--module--reporting--service_ensure)
* [`service_enable`](#-icingaweb2--module--reporting--service_enable)
* [`service_user`](#-icingaweb2--module--reporting--service_user)

##### <a name="-icingaweb2--module--reporting--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Ensures the state of the reporting module.

##### <a name="-icingaweb2--module--reporting--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/reporting"`

##### <a name="-icingaweb2--module--reporting--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

The upstream module repository.

##### <a name="-icingaweb2--module--reporting--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

The version of the module that needs to be used.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--reporting--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--reporting--db_type"></a>`db_type`

Data type: `Enum['mysql', 'pgsql']`

The database type. Either mysql or postgres.

##### <a name="-icingaweb2--module--reporting--db_resource_name"></a>`db_resource_name`

Data type: `String[1]`

Name for the reporting database resource.

##### <a name="-icingaweb2--module--reporting--db_host"></a>`db_host`

Data type: `Stdlib::Host`

The host where the reporting database will be running

##### <a name="-icingaweb2--module--reporting--db_port"></a>`db_port`

Data type: `Optional[Stdlib::Port]`

The port on which the database is accessible.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--db_name"></a>`db_name`

Data type: `String[1]`

The name of the database this module should use.

##### <a name="-icingaweb2--module--reporting--db_username"></a>`db_username`

Data type: `String[1]`

The username needed to access the database.

##### <a name="-icingaweb2--module--reporting--db_password"></a>`db_password`

Data type: `Optional[Icinga::Secret]`

The password needed to access the database.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--db_charset"></a>`db_charset`

Data type: `Optional[String[1]]`

The charset the database is set to.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--use_tls"></a>`use_tls`

Data type: `Optional[Boolean]`

Either enable or disable TLS encryption to the database. Other TLS parameters
are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--tls_key_file"></a>`tls_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--tls_cert_file"></a>`tls_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--tls_cacert_file"></a>`tls_cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the ca certificate. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--tls_key"></a>`tls_key`

Data type: `Optional[Icinga::Secret]`

The private key to store in spicified `tls_key_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--tls_cert"></a>`tls_cert`

Data type: `Optional[String[1]]`

The certificate to store in spicified `tls_cert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--tls_cacert"></a>`tls_cacert`

Data type: `Optional[String[1]]`

The ca certificate to store in spicified `tls_cacert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--tls_capath"></a>`tls_capath`

Data type: `Optional[Stdlib::Absolutepath]`

The file path to the directory that contains the trusted SSL CA certificates, which are stored in PEM format.
Only available for the mysql database.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--tls_noverify"></a>`tls_noverify`

Data type: `Optional[Boolean]`

Disable validation of the server certificate.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--tls_cipher"></a>`tls_cipher`

Data type: `Optional[String[1]]`

Cipher to use for the encrypted database connection.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--import_schema"></a>`import_schema`

Data type: `Optional[Icingaweb2::ImportSchema]`

Whether to import the database schema or not. Options `mariadb` and `mysql`,
both means true. With mariadb its cli options are used for the import,
whereas with mysql its different options.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--mail"></a>`mail`

Data type: `Optional[String[1]]`

Mails are sent with this sender address.

Default value: `undef`

##### <a name="-icingaweb2--module--reporting--manage_service"></a>`manage_service`

Data type: `Boolean`

If set to true the service (daemon) is managed.

##### <a name="-icingaweb2--module--reporting--service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

Wether the service is `running` or `stopped`.

##### <a name="-icingaweb2--module--reporting--service_enable"></a>`service_enable`

Data type: `Boolean`

Whether the service should be started at boot time.

##### <a name="-icingaweb2--module--reporting--service_user"></a>`service_user`

Data type: `String[1]`

The user as which the service is running. Only valid if `install_method` is set to `git`.

### <a name="icingaweb2--module--translation"></a>`icingaweb2::module::translation`

Installs and configures the translation module.

#### Parameters

The following parameters are available in the `icingaweb2::module::translation` class:

* [`ensure`](#-icingaweb2--module--translation--ensure)

##### <a name="-icingaweb2--module--translation--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

### <a name="icingaweb2--module--vspheredb"></a>`icingaweb2::module::vspheredb`

Installs the vsphereDB plugin

#### Examples

##### 

```puppet
class { 'icingaweb2::module::vspheredb':
  ensure       => 'present',
  git_revision => 'v1.1.0',
  db_host      => 'localhost',
  db_name      => 'vspheredb',
  db_username  => 'vspheredb',
  db_password  => 'supersecret',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::vspheredb` class:

* [`ensure`](#-icingaweb2--module--vspheredb--ensure)
* [`module_dir`](#-icingaweb2--module--vspheredb--module_dir)
* [`git_repository`](#-icingaweb2--module--vspheredb--git_repository)
* [`git_revision`](#-icingaweb2--module--vspheredb--git_revision)
* [`install_method`](#-icingaweb2--module--vspheredb--install_method)
* [`package_name`](#-icingaweb2--module--vspheredb--package_name)
* [`db_type`](#-icingaweb2--module--vspheredb--db_type)
* [`db_resource_name`](#-icingaweb2--module--vspheredb--db_resource_name)
* [`db_host`](#-icingaweb2--module--vspheredb--db_host)
* [`db_port`](#-icingaweb2--module--vspheredb--db_port)
* [`db_name`](#-icingaweb2--module--vspheredb--db_name)
* [`db_username`](#-icingaweb2--module--vspheredb--db_username)
* [`db_password`](#-icingaweb2--module--vspheredb--db_password)
* [`db_charset`](#-icingaweb2--module--vspheredb--db_charset)
* [`use_tls`](#-icingaweb2--module--vspheredb--use_tls)
* [`tls_key_file`](#-icingaweb2--module--vspheredb--tls_key_file)
* [`tls_cert_file`](#-icingaweb2--module--vspheredb--tls_cert_file)
* [`tls_cacert_file`](#-icingaweb2--module--vspheredb--tls_cacert_file)
* [`tls_key`](#-icingaweb2--module--vspheredb--tls_key)
* [`tls_cert`](#-icingaweb2--module--vspheredb--tls_cert)
* [`tls_cacert`](#-icingaweb2--module--vspheredb--tls_cacert)
* [`tls_capath`](#-icingaweb2--module--vspheredb--tls_capath)
* [`tls_noverify`](#-icingaweb2--module--vspheredb--tls_noverify)
* [`tls_cipher`](#-icingaweb2--module--vspheredb--tls_cipher)
* [`import_schema`](#-icingaweb2--module--vspheredb--import_schema)
* [`manage_service`](#-icingaweb2--module--vspheredb--manage_service)
* [`service_ensure`](#-icingaweb2--module--vspheredb--service_ensure)
* [`service_enable`](#-icingaweb2--module--vspheredb--service_enable)
* [`service_user`](#-icingaweb2--module--vspheredb--service_user)

##### <a name="-icingaweb2--module--vspheredb--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Ensur es the state of the vspheredb module.

##### <a name="-icingaweb2--module--vspheredb--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/vspheredb"`

##### <a name="-icingaweb2--module--vspheredb--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

The upstream module repository.

##### <a name="-icingaweb2--module--vspheredb--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

The version of the module that needs to be used.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--vspheredb--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--vspheredb--db_type"></a>`db_type`

Data type: `Enum['mysql']`

The database type. Either mysql or postgres.

##### <a name="-icingaweb2--module--vspheredb--db_resource_name"></a>`db_resource_name`

Data type: `String[1]`

Name for the vspheredb database resource.

##### <a name="-icingaweb2--module--vspheredb--db_host"></a>`db_host`

Data type: `Stdlib::Host`

The host where the vspheredb-database will be running

##### <a name="-icingaweb2--module--vspheredb--db_port"></a>`db_port`

Data type: `Optional[Stdlib::Port]`

The port on which the database is accessible.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--db_name"></a>`db_name`

Data type: `String[1]`

The name of the database this module should use.

##### <a name="-icingaweb2--module--vspheredb--db_username"></a>`db_username`

Data type: `String[1]`

The username needed to access the database.

##### <a name="-icingaweb2--module--vspheredb--db_password"></a>`db_password`

Data type: `Optional[Icinga::Secret]`

The password needed to access the database.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--db_charset"></a>`db_charset`

Data type: `Optional[String[1]]`

The charset the database is set to.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--use_tls"></a>`use_tls`

Data type: `Optional[Boolean]`

Either enable or disable TLS encryption to the database. Other TLS parameters
are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--tls_key_file"></a>`tls_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--tls_cert_file"></a>`tls_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--tls_cacert_file"></a>`tls_cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the ca certificate. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--tls_key"></a>`tls_key`

Data type: `Optional[Icinga::Secret]`

The private key to store in spicified `tls_key_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--tls_cert"></a>`tls_cert`

Data type: `Optional[String[1]]`

The certificate to store in spicified `tls_cert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--tls_cacert"></a>`tls_cacert`

Data type: `Optional[String[1]]`

The ca certificate to store in spicified `tls_cacert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--tls_capath"></a>`tls_capath`

Data type: `Optional[Stdlib::Absolutepath]`

The file path to the directory that contains the trusted SSL CA certificates, which are stored in PEM format.
Only available for the mysql database.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--tls_noverify"></a>`tls_noverify`

Data type: `Optional[Boolean]`

Disable validation of the server certificate.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--tls_cipher"></a>`tls_cipher`

Data type: `Optional[String[1]]`

Cipher to use for the encrypted database connection.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--import_schema"></a>`import_schema`

Data type: `Optional[Icingaweb2::ImportSchema]`

Whether to import the database schema or not. New options `mariadb` and `mysql`,
both means true. With mariadb its cli options are used for the import,
whereas with mysql its different options.

Default value: `undef`

##### <a name="-icingaweb2--module--vspheredb--manage_service"></a>`manage_service`

Data type: `Boolean`

If set to true the service (daemon) is managed.

##### <a name="-icingaweb2--module--vspheredb--service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

Wether the service is `running` or `stopped`.

##### <a name="-icingaweb2--module--vspheredb--service_enable"></a>`service_enable`

Data type: `Boolean`

Whether the service should be started at boot time.

##### <a name="-icingaweb2--module--vspheredb--service_user"></a>`service_user`

Data type: `String[1]`

The user as which the service is running. Only valid if `install_method` is set to `git`.

### <a name="icingaweb2--module--x509"></a>`icingaweb2::module::x509`

Installs the x509 module

#### Examples

##### 

```puppet
class { 'icingaweb2::module::x509':
  ensure       => present,
  git_revision => 'v1.2.1',
  db_host      => 'localhost',
  db_name      => 'x509',
  db_username  => 'x509',
  db_password  => Sensitive('supersecret'),
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module::x509` class:

* [`ensure`](#-icingaweb2--module--x509--ensure)
* [`module_dir`](#-icingaweb2--module--x509--module_dir)
* [`git_repository`](#-icingaweb2--module--x509--git_repository)
* [`git_revision`](#-icingaweb2--module--x509--git_revision)
* [`install_method`](#-icingaweb2--module--x509--install_method)
* [`package_name`](#-icingaweb2--module--x509--package_name)
* [`db_type`](#-icingaweb2--module--x509--db_type)
* [`db_resource_name`](#-icingaweb2--module--x509--db_resource_name)
* [`db_host`](#-icingaweb2--module--x509--db_host)
* [`db_port`](#-icingaweb2--module--x509--db_port)
* [`db_name`](#-icingaweb2--module--x509--db_name)
* [`db_username`](#-icingaweb2--module--x509--db_username)
* [`db_password`](#-icingaweb2--module--x509--db_password)
* [`db_charset`](#-icingaweb2--module--x509--db_charset)
* [`use_tls`](#-icingaweb2--module--x509--use_tls)
* [`tls_key_file`](#-icingaweb2--module--x509--tls_key_file)
* [`tls_cert_file`](#-icingaweb2--module--x509--tls_cert_file)
* [`tls_cacert_file`](#-icingaweb2--module--x509--tls_cacert_file)
* [`tls_key`](#-icingaweb2--module--x509--tls_key)
* [`tls_cert`](#-icingaweb2--module--x509--tls_cert)
* [`tls_cacert`](#-icingaweb2--module--x509--tls_cacert)
* [`tls_capath`](#-icingaweb2--module--x509--tls_capath)
* [`tls_noverify`](#-icingaweb2--module--x509--tls_noverify)
* [`tls_cipher`](#-icingaweb2--module--x509--tls_cipher)
* [`import_schema`](#-icingaweb2--module--x509--import_schema)
* [`manage_service`](#-icingaweb2--module--x509--manage_service)
* [`service_ensure`](#-icingaweb2--module--x509--service_ensure)
* [`service_enable`](#-icingaweb2--module--x509--service_enable)
* [`service_user`](#-icingaweb2--module--x509--service_user)

##### <a name="-icingaweb2--module--x509--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Ensures the state of the x509 module.

##### <a name="-icingaweb2--module--x509--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module.

Default value: `"${icingaweb2::globals::default_module_path}/x509"`

##### <a name="-icingaweb2--module--x509--git_repository"></a>`git_repository`

Data type: `Stdlib::HTTPUrl`

The upstream module repository.

##### <a name="-icingaweb2--module--x509--git_revision"></a>`git_revision`

Data type: `Optional[String[1]]`

The version of the module that needs to be used.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method.

##### <a name="-icingaweb2--module--x509--package_name"></a>`package_name`

Data type: `String[1]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

##### <a name="-icingaweb2--module--x509--db_type"></a>`db_type`

Data type: `Enum['mysql', 'pgsql']`

The database type. Either mysql or pgsql.

##### <a name="-icingaweb2--module--x509--db_resource_name"></a>`db_resource_name`

Data type: `String[1]`

Name for the x509 database resource.

##### <a name="-icingaweb2--module--x509--db_host"></a>`db_host`

Data type: `Stdlib::Host`

The host where the database will be running

##### <a name="-icingaweb2--module--x509--db_port"></a>`db_port`

Data type: `Optional[Stdlib::Port]`

The port on which the database is accessible.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--db_name"></a>`db_name`

Data type: `String[1]`

The name of the database this module should use.

##### <a name="-icingaweb2--module--x509--db_username"></a>`db_username`

Data type: `String[1]`

The username needed to access the database.

##### <a name="-icingaweb2--module--x509--db_password"></a>`db_password`

Data type: `Optional[Icinga::Secret]`

The password needed to access the database.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--db_charset"></a>`db_charset`

Data type: `Optional[String[1]]`

The charset the database is set to.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--use_tls"></a>`use_tls`

Data type: `Optional[Boolean]`

Either enable or disable TLS encryption to the database. Other TLS parameters
are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--tls_key_file"></a>`tls_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--tls_cert_file"></a>`tls_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--tls_cacert_file"></a>`tls_cacert_file`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the ca certificate. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--tls_key"></a>`tls_key`

Data type: `Optional[Icinga::Secret]`

The private key to store in spicified `tls_key_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--tls_cert"></a>`tls_cert`

Data type: `Optional[String[1]]`

The certificate to store in spicified `tls_cert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--tls_cacert"></a>`tls_cacert`

Data type: `Optional[String[1]]`

The ca certificate to store in spicified `tls_cacert_file` file. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--tls_capath"></a>`tls_capath`

Data type: `Optional[Stdlib::Absolutepath]`

The file path to the directory that contains the trusted SSL CA certificates, which are stored in PEM format.
Only available for the mysql database.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--tls_noverify"></a>`tls_noverify`

Data type: `Optional[Boolean]`

Disable validation of the server certificate.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--tls_cipher"></a>`tls_cipher`

Data type: `Optional[String[1]]`

Cipher to use for the encrypted database connection.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--import_schema"></a>`import_schema`

Data type: `Optional[Icingaweb2::ImportSchema]`

Whether to import the database schema or not. Options `mariadb` and `mysql`,
both means true. With mariadb its cli options are used for the import,
whereas with mysql its different options.

Default value: `undef`

##### <a name="-icingaweb2--module--x509--manage_service"></a>`manage_service`

Data type: `Boolean`

If set to true the service (daemon) is managed.

##### <a name="-icingaweb2--module--x509--service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

Wether the service is `running` or `stopped`.

##### <a name="-icingaweb2--module--x509--service_enable"></a>`service_enable`

Data type: `Boolean`

Whether the service should be started at boot time.

##### <a name="-icingaweb2--module--x509--service_user"></a>`service_user`

Data type: `String[1]`

The user as which the service is running. Only valid if `install_method` is set to `git`.

## Defined types

### <a name="icingaweb2--config--authmethod"></a>`icingaweb2::config::authmethod`

Manage Icinga Web 2 authentication methods. Auth methods may be chained by setting proper ordering.

#### Examples

##### Create an authentication method (db) and reference to a resource:

```puppet
icingaweb2::config::authmethod { 'db-auth':
  backend  => 'db',
  resource => 'my-sql',
  order    => 20,
}
```

##### Create a LDAP authmethod:

```puppet
icingaweb2::config::authmethod { 'ldap-auth':
  backend                  => 'ldap',
  resource                 => 'my-ldap',
  ldap_user_class          => 'user',
  ldap_filter              => '(memberof:1.2.840.113556.1.4.1941:=CN=monitoring,OU=groups,DC=icinga,DC=com)',
  ldap_user_name_attribute => 'userPrincipalName',
  order                    => '05',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::config::authmethod` defined type:

* [`backend`](#-icingaweb2--config--authmethod--backend)
* [`resource`](#-icingaweb2--config--authmethod--resource)
* [`ldap_user_class`](#-icingaweb2--config--authmethod--ldap_user_class)
* [`ldap_user_name_attribute`](#-icingaweb2--config--authmethod--ldap_user_name_attribute)
* [`ldap_filter`](#-icingaweb2--config--authmethod--ldap_filter)
* [`ldap_base_dn`](#-icingaweb2--config--authmethod--ldap_base_dn)
* [`domain`](#-icingaweb2--config--authmethod--domain)
* [`order`](#-icingaweb2--config--authmethod--order)

##### <a name="-icingaweb2--config--authmethod--backend"></a>`backend`

Data type: `Enum['external', 'ldap', 'msldap', 'db']`

Select between 'external', 'ldap', 'msldap' or 'db'. Each backend may require other settings.

##### <a name="-icingaweb2--config--authmethod--resource"></a>`resource`

Data type: `Optional[String]`

The name of the resource defined in resources.ini.

Default value: `undef`

##### <a name="-icingaweb2--config--authmethod--ldap_user_class"></a>`ldap_user_class`

Data type: `Optional[String]`

LDAP user class. Only valid if `backend` is `ldap` or `msldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--authmethod--ldap_user_name_attribute"></a>`ldap_user_name_attribute`

Data type: `Optional[String]`

LDAP attribute which contains the username. Only valid if `backend` is `ldap` or `msldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--authmethod--ldap_filter"></a>`ldap_filter`

Data type: `Optional[String]`

LDAP search filter. Only valid if `backend` is `ldap` or `msladap`.

Default value: `undef`

##### <a name="-icingaweb2--config--authmethod--ldap_base_dn"></a>`ldap_base_dn`

Data type: `Optional[String]`

LDAP base DN. Only valid if `backend` is `ldap` or `msldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--authmethod--domain"></a>`domain`

Data type: `Optional[String]`

Domain for domain-aware authentication

Default value: `undef`

##### <a name="-icingaweb2--config--authmethod--order"></a>`order`

Data type: `Variant[String, Integer]`

Multiple authentication methods can be chained. The order of entries in the authentication
configuration determines the order of the authentication methods.

Default value: `'30'`

### <a name="icingaweb2--config--dashboard"></a>`icingaweb2::config::dashboard`

Manage a dashboard.

#### Examples

##### Create a new Dashboard:

```puppet
icingaweb2::config::dashboard { 'icingaadmin-NewDashboard':
  owner     => 'icingaadmin',
  dashboard => 'New Dashboard',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::config::dashboard` defined type:

* [`owner`](#-icingaweb2--config--dashboard--owner)
* [`dashboard`](#-icingaweb2--config--dashboard--dashboard)

##### <a name="-icingaweb2--config--dashboard--owner"></a>`owner`

Data type: `String`

Owner of the dashboard.

##### <a name="-icingaweb2--config--dashboard--dashboard"></a>`dashboard`

Data type: `String`

Title of the dashboard.

### <a name="icingaweb2--config--dashlet"></a>`icingaweb2::config::dashlet`

Manage a dashlet.

#### Examples

##### Create a new Dashboard with a Dashlet:

```puppet
icingaweb2::config::dashboard { 'icingaadmin-NewDashboard':
  owner     => 'icingaadmin',
  dashboard => 'New Dashboard',
}

icingaweb2::config::dashlet { 'icingaadmin-NewDashboard':
  owner     => 'icingaadmin',
  dashboard => 'New Dashboard',
  dashlet   => 'New Dashlet',
  url       => 'monitoring/list/hosts',
}
```

##### Add new Dashlet to an existing default dashboard:

```puppet
icingaweb2::config::dashlet { 'icingaadmin-Overdue-NewDashlet':
  owner     => 'icingaadmin',
  dashboard => 'Overdue',
  dashlet   => 'New Dashlet',
  url       => 'monitoring/list/hosts',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::config::dashlet` defined type:

* [`owner`](#-icingaweb2--config--dashlet--owner)
* [`dashboard`](#-icingaweb2--config--dashlet--dashboard)
* [`dashlet`](#-icingaweb2--config--dashlet--dashlet)
* [`url`](#-icingaweb2--config--dashlet--url)

##### <a name="-icingaweb2--config--dashlet--owner"></a>`owner`

Data type: `String`

Owner of the dashlet.

##### <a name="-icingaweb2--config--dashlet--dashboard"></a>`dashboard`

Data type: `String`

Dashboard to which the dashlet belongs.

##### <a name="-icingaweb2--config--dashlet--dashlet"></a>`dashlet`

Data type: `String`

Name of the dashlet.

##### <a name="-icingaweb2--config--dashlet--url"></a>`url`

Data type: `String`

URL of the dashlet.

### <a name="icingaweb2--config--groupbackend"></a>`icingaweb2::config::groupbackend`

Groups of users can be stored either in a database, LDAP or ActiveDirectory. This defined type configures backends
that store groups.

#### Examples

##### A group backend for groups stored in LDAP:

```puppet
icingaweb2::config::groupbackend { 'ldap-groups':
  backend                     => 'ldap',
  resource                    => 'my-ldap',
  ldap_group_class            => 'group',
  ldap_group_name_attribute   => 'cn',
  ldap_group_member_attribute => 'member',
  ldap_base_dn                => 'ou=groups,dc=icinga,dc=com',
  domain                      => 'icinga.com',
}
```

##### If you have imported the database schema (parameter `import_schema`), this backend was also created automatically:

```puppet
icingaweb2::config::groupbackend { 'mysql-backend':
  backend  => 'db',
  resource => 'my-sql',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::config::groupbackend` defined type:

* [`group_name`](#-icingaweb2--config--groupbackend--group_name)
* [`backend`](#-icingaweb2--config--groupbackend--backend)
* [`resource`](#-icingaweb2--config--groupbackend--resource)
* [`ldap_user_backend`](#-icingaweb2--config--groupbackend--ldap_user_backend)
* [`ldap_group_class`](#-icingaweb2--config--groupbackend--ldap_group_class)
* [`ldap_group_filter`](#-icingaweb2--config--groupbackend--ldap_group_filter)
* [`ldap_group_name_attribute`](#-icingaweb2--config--groupbackend--ldap_group_name_attribute)
* [`ldap_group_member_attribute`](#-icingaweb2--config--groupbackend--ldap_group_member_attribute)
* [`ldap_base_dn`](#-icingaweb2--config--groupbackend--ldap_base_dn)
* [`ldap_nested_group_search`](#-icingaweb2--config--groupbackend--ldap_nested_group_search)
* [`domain`](#-icingaweb2--config--groupbackend--domain)
* [`order`](#-icingaweb2--config--groupbackend--order)

##### <a name="-icingaweb2--config--groupbackend--group_name"></a>`group_name`

Data type: `String`

Name of the resources. Resources are referenced by their name in other configuration sections.

Default value: `$title`

##### <a name="-icingaweb2--config--groupbackend--backend"></a>`backend`

Data type: `Enum['db', 'ldap', 'msldap']`

Type of backend. Valide values are: `db`, `ldap` and `msldap`. Each backend supports different settings,
see the parameters for detailed information.

##### <a name="-icingaweb2--config--groupbackend--resource"></a>`resource`

Data type: `String`

The resource used to connect to the backend. The resource contains connection information.

##### <a name="-icingaweb2--config--groupbackend--ldap_user_backend"></a>`ldap_user_backend`

Data type: `Optional[String]`

A group backend can be connected with an authentication method. This parameter references the auth method.
Only valid with backend `ldap` or `msldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--groupbackend--ldap_group_class"></a>`ldap_group_class`

Data type: `Optional[String]`

Class used to identify group objects. Only valid with backend `ldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--groupbackend--ldap_group_filter"></a>`ldap_group_filter`

Data type: `Optional[String]`

Use a LDAP filter to receive only certain groups. Only valid with backend `ldap` or `msldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--groupbackend--ldap_group_name_attribute"></a>`ldap_group_name_attribute`

Data type: `Optional[String]`

The group name attribute. Only valid with backend `ldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--groupbackend--ldap_group_member_attribute"></a>`ldap_group_member_attribute`

Data type: `Optional[String]`

The group member attribute. Only valid with backend `ldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--groupbackend--ldap_base_dn"></a>`ldap_base_dn`

Data type: `Optional[String]`

Base DN that is searched for groups. Only valid with backend `ldap` with `msldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--groupbackend--ldap_nested_group_search"></a>`ldap_nested_group_search`

Data type: `Optional[Boolean]`

Search for groups in groups. Only valid with backend `msldap`.

Default value: `undef`

##### <a name="-icingaweb2--config--groupbackend--domain"></a>`domain`

Data type: `Optional[String]`

Domain for domain-aware authentication.

Default value: `undef`

##### <a name="-icingaweb2--config--groupbackend--order"></a>`order`

Data type: `Variant[String, Integer]`

Multiple authentication methods can be chained. The order of entries in the authentication
configuration determines the order of the authentication methods.

Default value: `'30'`

### <a name="icingaweb2--config--navigation"></a>`icingaweb2::config::navigation`

Navigate defines a menu entry, host- or service action.

#### Parameters

The following parameters are available in the `icingaweb2::config::navigation` defined type:

* [`item_name`](#-icingaweb2--config--navigation--item_name)
* [`owner`](#-icingaweb2--config--navigation--owner)
* [`type`](#-icingaweb2--config--navigation--type)
* [`shared`](#-icingaweb2--config--navigation--shared)
* [`users`](#-icingaweb2--config--navigation--users)
* [`groups`](#-icingaweb2--config--navigation--groups)
* [`parent`](#-icingaweb2--config--navigation--parent)
* [`target`](#-icingaweb2--config--navigation--target)
* [`url`](#-icingaweb2--config--navigation--url)
* [`icon`](#-icingaweb2--config--navigation--icon)
* [`filter`](#-icingaweb2--config--navigation--filter)

##### <a name="-icingaweb2--config--navigation--item_name"></a>`item_name`

Data type: `String`

Name of the menu entry, host- or service action.

Default value: `$title`

##### <a name="-icingaweb2--config--navigation--owner"></a>`owner`

Data type: `String`

Owner of the navigation item.

##### <a name="-icingaweb2--config--navigation--type"></a>`type`

Data type:

```puppet
Enum[
    'menu-item',
    'host-action',
    'service-action'
  ]
```

Type of the navigation item.

Default value: `'menu-item'`

##### <a name="-icingaweb2--config--navigation--shared"></a>`shared`

Data type: `Boolean`

Creates a shared navigation item.

Default value: `false`

##### <a name="-icingaweb2--config--navigation--users"></a>`users`

Data type: `Optional[Array[String]]`

List of users who have access to the element. Only valid if shared.

Default value: `undef`

##### <a name="-icingaweb2--config--navigation--groups"></a>`groups`

Data type: `Optional[Array[String]]`

List of user groups that have access to the element. Only valid if shared.

Default value: `undef`

##### <a name="-icingaweb2--config--navigation--parent"></a>`parent`

Data type: `Optional[String]`

The name of the a parent item. Only valid for menu entries.
Important: `shared` has to set if the parent entry is also `shared`.

Default value: `undef`

##### <a name="-icingaweb2--config--navigation--target"></a>`target`

Data type: `Enum['_blank', '_main']`

The target to view the content.

Default value: `'_main'`

##### <a name="-icingaweb2--config--navigation--url"></a>`url`

Data type: `String`

Url to the content of the navigation item.

##### <a name="-icingaweb2--config--navigation--icon"></a>`icon`

Data type: `Optional[String]`

Location of an icon for the navigation item.

Default value: `undef`

##### <a name="-icingaweb2--config--navigation--filter"></a>`filter`

Data type: `Optional[String]`

Filter to restrict the result of the content. Only valid for actions.

Default value: `undef`

### <a name="icingaweb2--config--role"></a>`icingaweb2::config::role`

Roles define a set of permissions that may be applied to users or groups.

#### Examples

##### Create role that allows only hosts beginning with `linux-*`:

```puppet
icingaweb2::config::role{ 'linux-user':
  groups      => 'linuxer',
  permissions => '*',
  filters     => {
    'monitoring/filter/objects' => 'host_name=linux-*'
  }
}
```

#### Parameters

The following parameters are available in the `icingaweb2::config::role` defined type:

* [`role_name`](#-icingaweb2--config--role--role_name)
* [`users`](#-icingaweb2--config--role--users)
* [`groups`](#-icingaweb2--config--role--groups)
* [`parent`](#-icingaweb2--config--role--parent)
* [`permissions`](#-icingaweb2--config--role--permissions)
* [`refusals`](#-icingaweb2--config--role--refusals)
* [`unrestricted`](#-icingaweb2--config--role--unrestricted)
* [`filters`](#-icingaweb2--config--role--filters)

##### <a name="-icingaweb2--config--role--role_name"></a>`role_name`

Data type: `String`

Name of the role.

Default value: `$title`

##### <a name="-icingaweb2--config--role--users"></a>`users`

Data type: `Optional[String]`

Comma separated list of users this role applies to.

Default value: `undef`

##### <a name="-icingaweb2--config--role--groups"></a>`groups`

Data type: `Optional[String]`

Comma separated list of groups this role applies to.

Default value: `undef`

##### <a name="-icingaweb2--config--role--parent"></a>`parent`

Data type: `Optional[String]`

The name of the role from which to inherit privileges.

Default value: `undef`

##### <a name="-icingaweb2--config--role--permissions"></a>`permissions`

Data type: `Optional[String]`

Comma separated lsit of permissions. Each module may add it's own permissions. Examples are
- Allow everything: '*'
- Allow config access: 'config/*'
- Allow access do module icingadb: 'module/icingadb'
- Allow scheduling checks: 'icingadb/command/schedule-checks'
- Grant admin permissions: 'admin'

Default value: `undef`

##### <a name="-icingaweb2--config--role--refusals"></a>`refusals`

Data type: `Optional[String]`

Refusals are used to deny access. So they’re the exact opposite of permissions.

Default value: `undef`

##### <a name="-icingaweb2--config--role--unrestricted"></a>`unrestricted`

Data type: `Optional[Boolean]`

If set to `true`, owners of this role are not restricted in any way.

Default value: `undef`

##### <a name="-icingaweb2--config--role--filters"></a>`filters`

Data type: `Hash`

Hash of filters. Modules may add new filter keys, some sample keys are:
- application/share/users
- application/share/groups
- icingadb/filter/objects
A string value is expected for each used key. For example:
- icingadb/filter/objects = "host_name!=*win*"

Default value: `{}`

### <a name="icingaweb2--inisection"></a>`icingaweb2::inisection`

Manage settings in INI configuration files.

#### Examples

##### Create the configuration file and set two settings for the section `global`:

```puppet
include icingawebeb2

icingaweb2::inisection { '/path/to/config.ini':
  settings => {
    'global' => {
      'setting1' => 'value',
      'setting2' => 'value',
    },
  },
}
```

#### Parameters

The following parameters are available in the `icingaweb2::inisection` defined type:

* [`target`](#-icingaweb2--inisection--target)
* [`section_name`](#-icingaweb2--inisection--section_name)
* [`settings`](#-icingaweb2--inisection--settings)
* [`order`](#-icingaweb2--inisection--order)
* [`replace`](#-icingaweb2--inisection--replace)

##### <a name="-icingaweb2--inisection--target"></a>`target`

Data type: `Stdlib::Absolutepath`

Absolute path to the configuration file.

##### <a name="-icingaweb2--inisection--section_name"></a>`section_name`

Data type: `String[1]`

Name of the target section. Settings are set under [$section_name]

Default value: `$title`

##### <a name="-icingaweb2--inisection--settings"></a>`settings`

Data type: `Hash`

A hash of settings and their settings. Single settings may be set to absent.

Default value: `{}`

##### <a name="-icingaweb2--inisection--order"></a>`order`

Data type: `Variant[String[1], Integer[1]]`

Ordering of the INI section within a file. Defaults to `01`

Default value: `'01'`

##### <a name="-icingaweb2--inisection--replace"></a>`replace`

Data type: `Boolean`

Specifies whether to overwrite the destination file if it already exists.

Default value: `true`

### <a name="icingaweb2--module"></a>`icingaweb2::module`

Download, enable and configure Icinga Web 2 modules.

* **Note** If you want to use `git` as `install_method`, the CLI `git` command has to be installed. You can manage it yourself as package resource or declare the package name in icingaweb2 class parameter `extra_packages`.

#### Examples

##### 

```puppet
$conf_dir        = $icingaweb2::globals::conf_dir
$module_conf_dir = "${conf_dir}/modules/mymodule"

$settings = {
  'section1' => {
    'target'   => "${module_conf_dir}/config1.ini",
    'settings' => {
      'setting1' => 'value1',
      'setting2' => 'value2',
    }
  },
  'section2' => {
    'target'   => "${module_conf_dir}/config2.ini",
    'settings' => {
      'setting3' => 'value3',
      'setting4' => 'value4',
    }
  }
}
```

#### Parameters

The following parameters are available in the `icingaweb2::module` defined type:

* [`ensure`](#-icingaweb2--module--ensure)
* [`module`](#-icingaweb2--module--module)
* [`module_dir`](#-icingaweb2--module--module_dir)
* [`install_method`](#-icingaweb2--module--install_method)
* [`git_repository`](#-icingaweb2--module--git_repository)
* [`git_revision`](#-icingaweb2--module--git_revision)
* [`package_name`](#-icingaweb2--module--package_name)
* [`settings`](#-icingaweb2--module--settings)

##### <a name="-icingaweb2--module--ensure"></a>`ensure`

Data type: `Enum['absent', 'present']`

Enable or disable module.

Default value: `'present'`

##### <a name="-icingaweb2--module--module"></a>`module`

Data type: `String[1]`

Name of the module.

Default value: `$title`

##### <a name="-icingaweb2--module--module_dir"></a>`module_dir`

Data type: `Stdlib::Absolutepath`

Target directory of the module. Defaults to first item of `module_path`.

Default value: `"${icingaweb2::globals::default_module_path}/${title}"`

##### <a name="-icingaweb2--module--install_method"></a>`install_method`

Data type: `Enum['git', 'none', 'package']`

Install methods are `git`, `package` and `none` is supported as installation method. Defaults to `git`

Default value: `'git'`

##### <a name="-icingaweb2--module--git_repository"></a>`git_repository`

Data type: `Optional[String[1]]`

The git repository. This setting is only valid in combination with the installation method `git`.

Default value: `undef`

##### <a name="-icingaweb2--module--git_revision"></a>`git_revision`

Data type: `String`

Tag or branch of the git repository. This setting is only valid in combination with the installation method `git`.

Default value: `'master'`

##### <a name="-icingaweb2--module--package_name"></a>`package_name`

Data type: `Optional[String[1]]`

Package name of the module. This setting is only valid in combination with the installation method `package`.

Default value: `undef`

##### <a name="-icingaweb2--module--settings"></a>`settings`

Data type: `Hash[String[1], Any]`

A hash with the module settings. Multiple configuration files with ini sections can be configured with this hash.
The `module_name` should be used as target directory for the configuration files.

Default value: `{}`

### <a name="icingaweb2--resource--database"></a>`icingaweb2::resource::database`

Create and remove Icinga Web 2 database resources.

#### Examples

##### Create a MySQL DB resource:

```puppet
icingaweb2::resource::database { 'mysql':
  type     => 'mysql',
  host     => 'localhost',
  port     => '3306',
  database => 'icingaweb2',
  username => 'icingaweb2',
  password => 'supersecret',
}
```

#### Parameters

The following parameters are available in the `icingaweb2::resource::database` defined type:

* [`resource_name`](#-icingaweb2--resource--database--resource_name)
* [`type`](#-icingaweb2--resource--database--type)
* [`host`](#-icingaweb2--resource--database--host)
* [`port`](#-icingaweb2--resource--database--port)
* [`database`](#-icingaweb2--resource--database--database)
* [`username`](#-icingaweb2--resource--database--username)
* [`password`](#-icingaweb2--resource--database--password)
* [`charset`](#-icingaweb2--resource--database--charset)
* [`use_tls`](#-icingaweb2--resource--database--use_tls)
* [`tls_noverify`](#-icingaweb2--resource--database--tls_noverify)
* [`tls_key`](#-icingaweb2--resource--database--tls_key)
* [`tls_cert`](#-icingaweb2--resource--database--tls_cert)
* [`tls_cacert`](#-icingaweb2--resource--database--tls_cacert)
* [`tls_capath`](#-icingaweb2--resource--database--tls_capath)
* [`tls_cipher`](#-icingaweb2--resource--database--tls_cipher)

##### <a name="-icingaweb2--resource--database--resource_name"></a>`resource_name`

Data type: `String[1]`

Name of the resources. Resources are referenced by their name in other configuration sections.

Default value: `$title`

##### <a name="-icingaweb2--resource--database--type"></a>`type`

Data type:

```puppet
Enum['mysql', 'pgsql', 'mssql',
  'oci', 'oracle', 'ibm', 'sqlite']
```

Set database type to connect.

##### <a name="-icingaweb2--resource--database--host"></a>`host`

Data type: `Optional[Stdlib::Host]`

Connect to the database on the given host. For using unix domain sockets, specify 'localhost' for
MySQL and the path to the unix domain socket and the directory for PostgreSQL.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--port"></a>`port`

Data type: `Optional[Stdlib::Port]`

Port number to use.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--database"></a>`database`

Data type: `String[1]`

The database to use.

##### <a name="-icingaweb2--resource--database--username"></a>`username`

Data type: `Optional[String[1]]`

The username to use when connecting to the server.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--password"></a>`password`

Data type: `Optional[Icinga::Secret]`

The password to use when connecting the database.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--charset"></a>`charset`

Data type: `Optional[String[1]]`

The character set to use for the database connection.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--use_tls"></a>`use_tls`

Data type: `Optional[Boolean]`

Either enable or disable TLS encryption to the database. Other TLS parameters
are only affected if this is set to 'true'.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--tls_noverify"></a>`tls_noverify`

Data type: `Optional[Boolean]`

Disable validation of the server certificate.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--tls_key"></a>`tls_key`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the private key for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--tls_cert"></a>`tls_cert`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the certificate for client authentication. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--tls_cacert"></a>`tls_cacert`

Data type: `Optional[Stdlib::Absolutepath]`

Location of the ca certificate. Only valid if tls is enabled.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--tls_capath"></a>`tls_capath`

Data type: `Optional[Stdlib::Absolutepath]`

The file path to the directory that contains the trusted SSL CA certificates, which are stored in PEM format.
Only available for the mysql database.

Default value: `undef`

##### <a name="-icingaweb2--resource--database--tls_cipher"></a>`tls_cipher`

Data type: `Optional[String[1]]`

Chipher to use for the encrypted database connection.

Default value: `undef`

### <a name="icingaweb2--resource--ldap"></a>`icingaweb2::resource::ldap`

Create and remove Icinga Web 2 resources. Resources may be referenced in other configuration sections.

#### Examples

##### Create a LDAP resource:

```puppet
icingaweb2::resource::ldap{ 'my-ldap':
  host    => 'localhost',
  port    => 389,
  root_dn => 'ou=users,dc=icinga,dc=com',
  bind_dn => 'cn=icingaweb2,ou=users,dc=icinga,dc=com',
  bind_pw => Sensitive('supersecret'),
}
```

#### Parameters

The following parameters are available in the `icingaweb2::resource::ldap` defined type:

* [`resource_name`](#-icingaweb2--resource--ldap--resource_name)
* [`host`](#-icingaweb2--resource--ldap--host)
* [`port`](#-icingaweb2--resource--ldap--port)
* [`root_dn`](#-icingaweb2--resource--ldap--root_dn)
* [`bind_dn`](#-icingaweb2--resource--ldap--bind_dn)
* [`bind_pw`](#-icingaweb2--resource--ldap--bind_pw)
* [`encryption`](#-icingaweb2--resource--ldap--encryption)
* [`timeout`](#-icingaweb2--resource--ldap--timeout)

##### <a name="-icingaweb2--resource--ldap--resource_name"></a>`resource_name`

Data type: `String[1]`

Name of the resources. Resources are referenced by their name in other configuration sections.

Default value: `$title`

##### <a name="-icingaweb2--resource--ldap--host"></a>`host`

Data type: `String[1]`

Connect to the database or ldap server on the given host. For using unix domain sockets, specify 'localhost' for
MySQL and the path to the unix domain socket directory for PostgreSQL. When using the 'ldap' type you can also
provide multiple hosts separated by a space.

Default value: `'localhost'`

##### <a name="-icingaweb2--resource--ldap--port"></a>`port`

Data type: `Optional[Stdlib::Port]`

Port number to use.

Default value: `undef`

##### <a name="-icingaweb2--resource--ldap--root_dn"></a>`root_dn`

Data type: `Optional[String[1]]`

Root object of the tree, e.g. 'ou=people,dc=icinga,dc=com'.

Default value: `undef`

##### <a name="-icingaweb2--resource--ldap--bind_dn"></a>`bind_dn`

Data type: `Optional[String[1]]`

The user to use when connecting to the server.

Default value: `undef`

##### <a name="-icingaweb2--resource--ldap--bind_pw"></a>`bind_pw`

Data type: `Optional[Icinga::Secret]`

The password to use when connecting to the server.

Default value: `undef`

##### <a name="-icingaweb2--resource--ldap--encryption"></a>`encryption`

Data type: `Enum['none', 'starttls', 'ldaps']`

Type of encryption to use: none (default), starttls, ldaps.

Default value: `'none'`

##### <a name="-icingaweb2--resource--ldap--timeout"></a>`timeout`

Data type: `Integer`

Timeout for the ldap connection.

Default value: `5`

## Functions

### <a name="icingaweb2--pick"></a>`icingaweb2::pick`

Type: Puppet Language

This function returns first parameter if set.

#### `icingaweb2::pick(Any $arg1, Any $arg2)`

The icingaweb2::pick function.

Returns: `Any` One of the two parameters.

##### `arg1`

Data type: `Any`



##### `arg2`

Data type: `Any`



## Data types

### <a name="Icingaweb2--AdminRole"></a>`Icingaweb2::AdminRole`

A strict type for the default admin role

Alias of

```puppet
Struct[{
    name   => String,
    users  => Optional[Array[String[1]]],
    groups => Optional[Array[String[1]]],
}]
```

### <a name="Icingaweb2--ImportSchema"></a>`Icingaweb2::ImportSchema`

A type for setting import database schemata

Alias of `Variant[Boolean, Enum['mariadb', 'mysql']]`

